'Preamble
'This software is released under the BSD License which is a certified
'open source license by the OPEN SOURCE INITIATIVE (OSI) and fulfilling
'the terms of this license is the only way to gain permission to use or
'modify this software in binary or any other form.
'
'Open Source Certification:
'This software is OSI Certified Open Source Software.
'OSI Certified is a certification mark of the Open Source Initiative.
'
'License.
'Copyright (c), 1999-2005 Fire Flower Cybernetics - All rights reserved.
'
'Redistribution and use in source and binary forms, with or without
'modification, are permitted provided that the following conditions are
'met:
'
'* Redistributions of source code must retain the above copyright notice,
'  this list of conditions and the following disclaimer.
'
'* Redistributions in binary form must reproduce the above copyright
'  notice, this list of conditions and the following disclaimer in the
'  documentation and/or other materials provided with the distribution.
'
'* Neither the name of Fire Flower Cybernetics nor the names of its
'  contributors may be used to endorse or promote products derived from
'  this software without specific prior written permission.
'
'THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
'"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
'LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
'A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
'OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
'SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
'LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
'DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
'THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
'(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
'OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
'
'$INCLUDE: 'qbx.bi'
'$INCLUDE: 'fastgraf.bi'
'$INCLUDE: 'fgfonts.bi'
'$INCLUDE: 'fgimage.bi'
'$DYNAMIC

DECLARE SUB TxtFG (A$)
DECLARE SUB Ini ()
DECLARE SUB delay (hun.scnds!)
DECLARE SUB BGDELAY (hun.scnds!, HUN.SCNDS.TO.GO!, Status%)
DECLARE SUB Word ()
DECLARE SUB Menu ()
DECLARE SUB Alfa ()
DECLARE SUB Page ()
DECLARE SUB Buttons ()
DECLARE SUB SelectLine ()
DECLARE SUB HighlightLine (LineNo%)
DECLARE SUB Paste2Line (ChrOrStr$, ArrNo%)
DECLARE SUB DeleteLine ()
DECLARE SUB DeleteBox ()
DECLARE SUB BackSpace ()
DECLARE SUB RealyExit ()
DECLARE SUB Number (NO%)
DECLARE SUB LoadPage ()
DECLARE SUB SendSerial (String2Send$)
DECLARE SUB CalcPCXDim (PcxSizeX%, PcxSizeY%)
DECLARE SUB Send2Lpt (A$)
DECLARE SUB Alarm (Ring%)
DECLARE SUB Chapter ()
DECLARE SUB LoadChapter ()
DECLARE SUB WriteLine (CursorOnOff%)
DECLARE SUB check ()
DECLARE SUB Picture ()
DECLARE SUB SubTitle (A$)
DECLARE SUB RTS (State%)
DECLARE SUB SetCom (PortNo%)

DECLARE FUNCTION DiskSerial$ (Dr AS INTEGER)
DECLARE FUNCTION GetCTS% ()


COMMON SHARED Group%, SelectedLine%, SelectedPage%, ComChan%, time.to.wait!
COMMON SHARED PrnStr$, PictoHandle%, FGIHandle%, SelectedChapter%
COMMON SHARED ComPortAddr%

DIM SHARED TheWords$(700)
DIM SHARED TheCompanion$(700)
DIM SHARED LineChr$(6)
DIM SHARED KeyWord$(12)
DIM SHARED TranslateTo%(255)
DIM SHARED PCXHeader AS STRING * 128
DIM SHARED Ring1%(14)
DIM SHARED Ring2%(15)
DIM SHARED Ring3%(15)
DIM SHARED Ring4%(15)
DIM SHARED RingFrekvens%(7)
DIM SHARED PicturSentence$(5)


Heap& = SETMEM(-5000)


' def fnCTICKS.def -- returns the number of clock ticks since midnight
'
'       Allows the caller to `mark' the time, with an optional offset
'       ahead in time.  Useful in timing routines
'
' USAGE:
'       HUN.SCNDS = 100
'       MARK! = FNCTICKS (HUN.SCNDS)  ' # of clock ticks that will
'                    'have occurred since midnite (in 1 sec. from now)
'
'input: HUN.SCNDS = hundredths of seconds from now
'output: TIME.MARK! = time marker calculated (clock ticks since midnight)
'
DEF fncticks! (hun.scnds!)
 REM'$INCLUDE: 'TICKS.def'
 ' Used by TIMERS to measure ticks per day
 TICKS.PER.SEC! = 1193180 / 65536
 SECS.PER.HR! = 60 * 60
 TICKS.PER.DAY! = TICKS.PER.SEC! * SECS.PER.HR! * 24

 '$DYNAMIC
 DIM Registers AS RegType
 Registers.ax = 0       'set AH (& AL) to 0 to get clock setting
 CALL Interrupt(&H1A, Registers, Registers)
 ''CALL int86(&H1A, VARPTR(registers%(0)), VARPTR(registers%(0)))
 cx! = Registers.cx: dx! = Registers.dx
 cticks! = (cx! * 2 ^ 16 + dx!) + (hun.scnds! / 100 * TICKS.PER.SEC!)
 IF cticks! > TICKS.PER.DAY! THEN cticks! = cticks! - TICKS.PER.DAY!'passed midnite
 fncticks! = FIX(cticks!)
END DEF

'***************************************************************
'*Remove Line when Compiling: CHDIR "d:\util\bc7\handy\tboard" *
'*Remove GOTO NC                                               *
'***************************************************************

CHDIR "d:\util\bc7\handy\tboard"

'********************************************************
'*check for to make sure that the FGI lib are accessibal*
'********************************************************

' *** Set Video Mode to 640 x 480 x 256
I% = FGsvgainit(0)
FGsetmode 25

'
'This is an pre open source thing that could look the
'program to a certain serial number of a disk, with
'help of a util that wrote into the exe file.
'
'Only reason it's left in is for DATA reading, it is
'Not activated.
'
check
'

PictoHandle% = FGIopen("default.fgi" + CHR$(0))
FGIHandle% = FGIopen("control.fgi" + CHR$(0))


Ini

Group% = 1

DO

 SELECT CASE Group%

  CASE 1
   IF KeyWord$(6) = "OFF" THEN
     Menu
    ELSE
     Group% = 2
   END IF
   
  CASE 2
   Word

  CASE 3
   Alfa

  CASE 4
   Buttons
  
  CASE 5
   Picture

  CASE 6
   Page

 END SELECT

LOOP

'R% = FGmakepcx(0, 639, 0, 479, "test.pcx" + CHR$(0))

Heap& = SETMEM(-5000)

'***setmode

'*****************************************
DATA <>\%&/()=!#@${[]}?+~^*<>\%&/()=!
DATA 3C3E5C25262F28293D2123CF40247B5B5D7D3F2BEFF97E5E2AABF53C3E5C25262F28293D21
'*****************************************


'**KeyWord 1 (1|2|Off0)
DATA [COM]

'**KeyWord 2 (On|Off)
DATA [NUMBERS]

'**KeyWord 3 (On|Off)
DATA [PICTURES]

'**KeyWord 4 (On|Off)
DATA [SYMBOLS]

'**KeyWord 5 (well time to pause)
DATA [TIMER]

'**KeyWord 6 (On|Off)
DATA [LOCK MENU]

'**KeyWord 7 (On|Off)
DATA [CHARACTERS]

'**KeyWord 8 (On|Off)
DATA [PRINTER]

'**KeyWord 9 (On|Off)
DATA [PRINTER STRING]

'**KeyWord 10 (1|2|3|4|5|6|7|8)
DATA [ALARM]

'**KeyWord 11 (1|2|3|4|5|6|7|8|9|10)
DATA [CHAPTER]

'**KeyWord 12 (1|2)
DATA [COM MODE]

'***4 typical phone ring sound
DATA 3,3,3,4,4,4,2,2,2,7,7,7,6,6,6
DATA 1,3,1,3,1,3,1,3,1,3,1,3,1,3,1,3
DATA 4,5,4,5,4,5,4,5,4,5,4,5,4,5,4,5
DATA 4,4,4,0,4,4,4,0,4,4,4,4,4,4,0,0

'***Ring tone Hz
DATA 0,533,600,667,800,1000,1067,1333

REM $STATIC
SUB Alarm (Ring%)

'**Erase symbol/Picture
FGsetcolor 1
FGrect 13, 234, 205, 404

'***show alarm icon
FGmove 13, 219
R% = FGIdisplay("bell.spr" + CHR$(0), 0, FGIHandle%)'**Load new chapter

SELECT CASE Ring%

 CASE 1 '***Ring 1
  FOR M% = 1 TO 5
   FOR N% = 0 TO 14
    SOUND RingFrekvens%(Ring1%(N%)), .9
   NEXT N%
   FGwaitfor 10
  NEXT M%

 CASE 2 '***Ring 2
  FOR M% = 1 TO 5
   FOR N% = 0 TO 15
    SOUND RingFrekvens%(Ring2%(N%)), .9
   NEXT N%
   FGwaitfor 10
  NEXT M%

 CASE 3 '***Ring 3
  FOR M% = 1 TO 5
   FOR N% = 0 TO 15
    SOUND RingFrekvens%(Ring3%(N%)), .9
   NEXT N%
   FGwaitfor 10
  NEXT M%

 CASE 4 '***Ring 4
  FOR M% = 1 TO 5
   FOR N% = 0 TO 15
    SOUND RingFrekvens%(Ring4%(N%)), .9
   NEXT N%
   FGwaitfor 10
  NEXT M%

 CASE 5 '***Klaxon
  Hi% = 987
  Low% = 329
  FOR N% = 0 TO 3
   SOUND Hi%, 5
   SOUND Low%, 5
  NEXT N%
  SOUND Hi%, 5

 CASE 6 '***Bounce
  Hi% = 32767
  Low% = 246
  FOR Count% = 60 TO 1 STEP -2
   SOUND Low% - Count% / 2, Count% / 20
   SOUND Hi%, Count% / 15
  NEXT Count%

 CASE 7 '***Fall
  Hi% = 2000
  Low% = 550
  Del% = 500
  FOR Count% = Hi% TO Low% STEP -10
   SOUND Count%, Del% / Count%
  NEXT Count%

 CASE 8 '***Wailing Siren
  Hi% = 780
  Range% = 650
  FOR Count% = Range% TO -Range% STEP -4
   SOUND Hi% - ABS(Count%), .3
   Count% = Count% - 2 / Range%
  NEXT Count%

 CASE ELSE '***Not a legal Parameter=no sound
		    
END SELECT

'***erase alarm icon
FGsetcolor 1
FGrect 13, 234, 205, 404

END SUB

SUB Alfa

 '--> 14
 '|
 '| 16
 'V

DO


 DO
  '**Menu
  '**Erase colum for symbol/Picture
  FGsetcolor 1
  FGrect 13, 234, 205, 404

  FGsetcolor 11
  FGboxdepth 31, 1
  FGboxx 291, 352, 205, 259

  DO
   CALL BGDELAY(time.to.wait!, time.to.go!, st%)
   FGwaitfor 1  'Slow fast machines down for keyboard "poll"
   IF INKEY$ <> "" THEN ExitLater% = 1
   JBut% = FGbutton(1)
   IF JBut% <> 0 THEN
    DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
    ExitLater% = 1
   END IF
  LOOP UNTIL st% = 0

  FGboxx 291, 352, 205, 259

  IF ExitLater% = 1 THEN
   Group% = 1
   EXIT SUB
  END IF

  AddX% = 0
  MinX% = 405
  MaxX% = 418

  FGsetcolor 11
  FGboxdepth 7, 1

     

 FOR Colum% = 1 TO 14

  FGsetcolor 11
  FGboxx MinX% + AddX%, MaxX% + AddX%, 182, 404

  '***set number Displayed
  IF KeyWord$(2) = "ON" THEN
   Number Colum%
   FGsetcolor 7
   FGmove 26, 220
   FGcirclef 10
  END IF


  DO
   CALL BGDELAY(time.to.wait!, time.to.go!, st%)
   FGwaitfor 1  'Slow fast machines down for keyboard "poll"
   IF INKEY$ <> "" THEN GOSUB ATheKey
   JBut% = FGbutton(1)
   IF JBut% <> 0 THEN
    DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
    GOSUB ATheKey
   END IF
  LOOP UNTIL st% = 0

  FGsetcolor 11
  FGboxx MinX% + AddX%, MaxX% + AddX%, 182, 404

  AddX% = AddX% + 16
  IF KeyTrap% = 1 THEN EXIT FOR

 NEXT Colum%

 AddX% = AddX% - 16

 LOOP UNTIL KeyTrap% = 1
 KeyTrap% = 0

'**
 DO: FGwaitfor 1: LOOP UNTIL INKEY$ = ""
'**

 DO

  '**Erase colum for symbol/Picture
  FGsetcolor 1
  FGrect 13, 234, 205, 404

  '**Menu
  FGsetcolor 11
  FGboxdepth 31, 1
  FGboxx 291, 352, 205, 259

  DO
   CALL BGDELAY(time.to.wait!, time.to.go!, st%)
   FGwaitfor 1  'Slow fast machines down for keyboard "poll"
   IF INKEY$ <> "" THEN ExitLater% = 1
   JBut% = FGbutton(1)
   IF JBut% <> 0 THEN
    DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
    ExitLater% = 1
   END IF
  LOOP UNTIL st% = 0

  FGboxx 291, 352, 205, 259
  FGboxdepth 43, 1

  IF ExitLater% = 1 THEN
   Group% = 1
   EXIT SUB
  END IF

  MinY% = 182
  MaxY% = 194

  FGsetcolor 11
  FGboxdepth 7, 1

  AddY% = 0

  FOR Row% = 1 TO 16

   FGsetcolor 11
   FGboxx MinX% + AddX%, MaxX% + AddX%, MinY% + AddY%, MaxY% + AddY%

   '***Set Zoom CHR
   IF KeyWord$(7) = "ON" THEN
    '***Enlarge character
    BigX% = 66: BigY% = 250
    FOR N% = MinY% + AddY% TO MaxY% + AddY%
     FOR M% = MinX% + AddX% TO MaxX% + AddX%
      col% = FGgetpixel(M%, N%)
      IF col% = 10 THEN
	FGsetcolor 1
       ELSE
	FGsetcolor 7
      END IF
      FGmove BigX%, BigY%
      FGrect BigX%, BigX% + 8, BigY%, BigY% + 8
      BigX% = BigX% + 8
     NEXT M%
     BigY% = BigY% + 8
     BigX% = 66
    NEXT N%
   END IF

   DO
    CALL BGDELAY(time.to.wait!, time.to.go!, st%)
    FGwaitfor 1  'Slow fast machines down for keyboard "poll"
    IF INKEY$ <> "" THEN GOSUB ATheKey
    JBut% = FGbutton(1)
    IF JBut% <> 0 THEN
     DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
     GOSUB ATheKey
    END IF
   LOOP UNTIL st% = 0

   FGsetcolor 11
   FGboxx MinX% + AddX%, MaxX% + AddX%, MinY% + AddY%, MaxY% + AddY%

   AddY% = AddY% + 14

   IF KeyTrap% = 1 THEN EXIT FOR

  NEXT Row%

 LOOP UNTIL KeyTrap% = 1
 
 AddY% = AddY% - 14

 '** 32767 is higher than any ArrNo% and are passed to indicate
 '** Alfa sub as the caller
 Paste2Line CHR$((Colum% + ((Row% * 14) - 14) - 1) + 32), 32767

 DO: FGwaitfor 1: LOOP UNTIL INKEY$ = ""
 KeyTrap% = 0

LOOP


EXIT SUB

ATheKey:

 KeyTrap% = 1

RETURN

END SUB

SUB BackSpace

HighlightLine (SelectedLine%)

DO
  '**Menu
  '**Erase colum for symbol/Picture
  FGsetcolor 1
  FGrect 13, 234, 205, 404

  FGsetcolor 11
  FGboxdepth 31, 1
  FGboxx 291, 352, 205, 259

  DO
   CALL BGDELAY(time.to.wait!, time.to.go!, st%)
   FGwaitfor 1  'Slow fast machines down for keyboard "poll"
   IF INKEY$ <> "" THEN ExitLater% = 1
    JBut% = FGbutton(1)
    IF JBut% <> 0 THEN
     DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
     ExitLater% = 1
    END IF
  LOOP UNTIL st% = 0

  FGboxx 291, 352, 205, 259

  IF ExitLater% = 1 THEN
   HighlightLine (SelectedLine%)
   EXIT SUB
  END IF

  HighlightLine (SelectedLine%)

  DO
   CALL BGDELAY(time.to.wait!, time.to.go!, st%)
   FGwaitfor 1  'Slow fast machines down for keyboard "poll"
   IF INKEY$ <> "" THEN GOSUB back
   JBut% = FGbutton(1)
   IF JBut% <> 0 THEN
    DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
    GOSUB back
   END IF
  LOOP UNTIL st% = 0

  HighlightLine (SelectedLine%)

LOOP

back:

'***Edit string
IF LEN(LineChr$(SelectedLine%)) > 0 THEN
 LineChr$(SelectedLine%) = MID$(LineChr$(SelectedLine%), 1, LEN(LineChr$(SelectedLine%)) - 1)
END IF

'***Update picture sentence
IF LEN(PicturSentence$(SelectedLine% - 1)) > 0 THEN

 '**Find type indicator
 FOR ChrPos% = LEN(PicturSentence$(SelectedLine% - 1)) TO 2 STEP -1
  TestChr$ = MID$(PicturSentence$(SelectedLine% - 1), ChrPos% - 1, 2)
  IF TestChr$ = "{]" OR TestChr$ = "(]" OR TestChr$ = "[)" THEN
   PicEdChoice$ = TestChr$
   ChrPos% = ChrPos% - 2
   EXIT FOR
  END IF
 NEXT ChrPos%
 IF ChrPos% = 0 THEN ChrPos% = 1


NoPicWord2Letter:

 SELECT CASE PicEdChoice$

  CASE "{]" '**Single Chr (no Picture)
   IF ChrPos% = 1 THEN
     PicturSentence$(SelectedLine% - 1) = ""
    ELSE
     PicturSentence$(SelectedLine% - 1) = MID$(PicturSentence$(SelectedLine% - 1), 1, LEN(PicturSentence$(SelectedLine% - 1)) - 3)
   END IF
  
  CASE "(]" '**Word, convert word to letters and delete ending space
   IF ChrPos% = 1 THEN
     EditString$ = RTRIM$(MID$(PicturSentence$(SelectedLine% - 1), ChrPos% + 2, LEN(PicturSentence$(SelectedLine% - 1)) - ChrPos%))
    ELSE
     EditString$ = RTRIM$(MID$(PicturSentence$(SelectedLine% - 1), ChrPos% + 3, LEN(PicturSentence$(SelectedLine% - 1)) - ChrPos%))
   END IF

   NewStringEnd$ = ""

   FOR LetterMaker% = 1 TO LEN(EditString$)
    NewStringEnd$ = NewStringEnd$ + "{]" + MID$(EditString$, LetterMaker%, 1)
   NEXT LetterMaker%

   IF ChrPos% = 1 THEN
     PicturSentence$(SelectedLine% - 1) = NewStringEnd$
    ELSE
     PicturSentence$(SelectedLine% - 1) = LEFT$(PicturSentence$(SelectedLine% - 1), ChrPos%) + NewStringEnd$
   END IF

   PicturSentence$(SelectedLine% - 1) = RTRIM$(PicturSentence$(SelectedLine% - 1))
   IF RIGHT$(RTRIM$(PicturSentence$(SelectedLine% - 1)), 2) = "{]" THEN
    PicturSentence$(SelectedLine% - 1) = LEFT$(RTRIM$(PicturSentence$(SelectedLine% - 1)), LEN(RTRIM$(PicturSentence$(SelectedLine% - 1))) - 2)
   END IF

  CASE "[)" '**Picture+Word
   '**If a picture is indicated change indicator to word indicator ("[) -> (]")
   IF ChrPos% = 1 THEN
     MID$(PicturSentence$(SelectedLine% - 1), ChrPos%, 2) = "(]"
    ELSE
     MID$(PicturSentence$(SelectedLine% - 1), ChrPos% + 1, 2) = "(]"
   END IF
   '**remove picturename from string
   FOR PicNameDot% = ChrPos% TO LEN(PicturSentence$(SelectedLine% - 1))
    TestChr$ = MID$(PicturSentence$(SelectedLine% - 1), PicNameDot%, 1)
    IF TestChr$ = "." THEN EXIT FOR
   NEXT PicNameDot%
   IF ChrPos% = 1 THEN
     PicturSentence$(SelectedLine% - 1) = LEFT$(PicturSentence$(SelectedLine% - 1), ChrPos% + 1) + RIGHT$(PicturSentence$(SelectedLine% - 1), LEN(PicturSentence$(SelectedLine% - 1)) - (PicNameDot% + 3))
    ELSE
     PicturSentence$(SelectedLine% - 1) = LEFT$(PicturSentence$(SelectedLine% - 1), ChrPos% + 2) + RIGHT$(PicturSentence$(SelectedLine% - 1), LEN(PicturSentence$(SelectedLine% - 1)) - (PicNameDot% + 3))
     IF MID$(PicturSentence$(SelectedLine% - 1), ChrPos%, 1) <> " " THEN
      PicturSentence$(SelectedLine% - 1) = MID$(PicturSentence$(SelectedLine% - 1), 1, ChrPos%) + " " + MID$(PicturSentence$(SelectedLine% - 1), ChrPos% + 1)
      ChrPos% = ChrPos% + 1
     END IF
   END IF
   PicturSentence$(SelectedLine% - 1) = LTRIM$(PicturSentence$(SelectedLine% - 1))
   '** now we want to make our new word with no picture into letters
   PicEdChoice$ = "(]"
   GOTO NoPicWord2Letter

 END SELECT

FGsetcolor 0
FGrect 0, 639, 0, 14
FGsetcolor 11
FGlocate 0, 0
FGtext PicturSentence$(SelectedLine% - 1) + "", LEN(PicturSentence$(SelectedLine% - 1)) + 1

END IF

'***graphic update
HighlightLine (SelectedLine%)

SELECT CASE SelectedLine%
 CASE 1
  FGmove 16, 424
 CASE 2
  FGmove 16, 432
 CASE 3
  FGmove 16, 440
 CASE 4
  FGmove 16, 448
 CASE 5
  FGmove 16, 456
 CASE 6
  FGmove 16, 464
END SELECT

'get cursor
x% = FGgetxpos%
Y% = FGgetypos%

FGsetcolor 1
TxtFG (STRING$(76, CHR$(219)))

'reset cursor
FGmove x%, Y%

WriteLine (1)


RETURN

END SUB

REM $DYNAMIC
SUB BGDELAY (hun.scnds!, HUN.SCNDS.TO.GO!, Status%) STATIC
'----------------------------------------------------------------------------
' BigDelay Procedure: Performs a background delay, returning control to the
' caller after each check so that the caller may be doing something while
' waiting.
'----------------------------------------------------------------------------
REM '$MODULE: 'bgDELAY'
' input:  an integer representing the number of hundredth-seconds to delay
' delay == input: HUN.SCNDS! = hundredths of seconds
'         output: HUN.SCNDS.TO.GO! = hundredths of seconds until timeout
'         output: STATUS%   = 0 - delay is complete; 1 - delay is continuing
'/==========================================================================/
REM'$INCLUDE: 'TICKS.def'
' Used by TIMERS to measure ticks per day
TICKS.PER.SEC! = 1193180 / 65536
SECS.PER.HR! = 60 * 60
TICKS.PER.DAY! = TICKS.PER.SEC! * SECS.PER.HR! * 24

STATIC START.TIME!, ENDING.TIME!
IF Status% = 0 THEN             'entering for the first time this request
		  START.TIME! = fncticks(0)                  ' mark the current time
		  ENDING.TIME! = fncticks(hun.scnds!)        ' mark the ending time
		  IF ENDING.TIME! < START.TIME! THEN
					 ENDING.TIME! = ENDING.TIME! + TICKS.PER.DAY!
		  END IF
END IF

CURRENT.TIME! = fncticks(0)
IF CURRENT.TIME! < START.TIME! THEN
		  CURRENT.TIME! = CURRENT.TIME! + TICKS.PER.DAY!
END IF
TICKS.LEFT! = ENDING.TIME! - CURRENT.TIME!       'calculate ticks left to go
HUN.SCNDS.TO.GO! = (TICKS.LEFT! * 100) / TICKS.PER.SEC!' see Tech.Ref.

IF TICKS.LEFT! > 0 THEN
		  Status% = 1                         ' time has NOT run out
ELSE
		  Status% = 0                         ' delay is complete
END IF

exitsub:
EXIT SUB
END SUB

REM $STATIC
SUB Buttons

DO

 DO

  '**Menu
  '**Erase colum for symbol/Picture
  FGsetcolor 1
  FGrect 13, 234, 205, 404

  FGsetcolor 11
  FGboxdepth 31, 1
  FGboxx 291, 352, 205, 259

  DO
   CALL BGDELAY(time.to.wait!, time.to.go!, st%)
   FGwaitfor 1  'Slow fast machines down for keyboard "poll"
   IF INKEY$ <> "" THEN ExitLater% = 1
   JBut% = FGbutton(1)
   IF JBut% <> 0 THEN
    DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
    ExitLater% = 1
   END IF
  LOOP UNTIL st% = 0

  FGboxx 291, 352, 205, 259

  IF ExitLater% = 1 THEN
   Group% = 1
   EXIT SUB
  END IF


  FGsetcolor 11
  FGboxdepth 23, 1
  
  FOR Colum% = 1 TO 3

   SELECT CASE Colum%
    CASE 1
     MinX% = 243: MaxX% = 288
    CASE 2
     MinX% = 297: MaxX% = 342
    CASE 3
     MinX% = 351: MaxX% = 396
   END SELECT

   FGsetcolor 11
   FGboxx MinX%, MaxX%, 269, 331
   
   DO
    CALL BGDELAY(time.to.wait!, time.to.go!, st%)
    FGwaitfor 1  'Slow fast machines down for keyboard "poll"
    IF INKEY$ <> "" THEN GOSUB CTheKey
    JBut% = FGbutton(1)
    IF JBut% <> 0 THEN
     DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
     GOSUB CTheKey
    END IF
   LOOP UNTIL st% = 0

   FGboxx MinX%, MaxX%, 269, 331

   IF KeyTrap% = 1 THEN EXIT FOR

  NEXT Colum%

 LOOP UNTIL KeyTrap% = 1

 KeyTrap% = 0

 DO

  '**Menu
  FGsetcolor 11
  FGboxdepth 31, 1
  FGboxx 291, 352, 205, 259

  DO
   CALL BGDELAY(time.to.wait!, time.to.go!, st%)
   FGwaitfor 1  'Slow fast machines down for keyboard "poll"
   IF INKEY$ <> "" THEN ExitLater% = 1
   JBut% = FGbutton(1)
   IF JBut% <> 0 THEN
    DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
    ExitLater% = 1
   END IF
  LOOP UNTIL st% = 0

  FGboxx 291, 352, 205, 259

  IF ExitLater% = 1 THEN
   Group% = 1
   EXIT SUB
  END IF

  FGsetcolor 11
  FGboxdepth 23, 1

  FOR Row% = 1 TO 3

   SELECT CASE Row%
    CASE 1
     MinY% = 269: MaxY% = 283
    CASE 2
     MinY% = 293: MaxY% = 307
    CASE 3
     MinY% = 317: MaxY% = 331

   END SELECT

   FGsetcolor 11
   FGboxx MinX%, MaxX%, MinY%, MaxY%

   DO
    CALL BGDELAY(time.to.wait!, time.to.go!, st%)
    FGwaitfor 1  'Slow fast machines down for keyboard "poll"
    IF INKEY$ <> "" THEN GOSUB CTheKey
    JBut% = FGbutton(1)
    IF JBut% <> 0 THEN
     DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
     GOSUB CTheKey
    END IF
   LOOP UNTIL st% = 0


   FGboxx MinX%, MaxX%, MinY%, MaxY%

   '***Actions
   IF KeyTrap% = 1 AND MaxY% = 283 AND Colum% = 1 THEN SelectLine
   IF KeyTrap% = 1 AND MaxY% = 283 AND Colum% = 2 THEN
    SelectLine
    DeleteLine
   END IF
   IF KeyTrap% = 1 AND MaxY% = 283 AND Colum% = 3 THEN DeleteBox

   IF KeyTrap% = 1 AND MaxY% = 307 AND Colum% = 1 THEN BackSpace
   IF KeyTrap% = 1 AND MaxY% = 307 AND Colum% = 2 AND ComChan% <> 0 THEN SendSerial LineChr$(SelectedLine%)
   IF KeyTrap% = 1 AND MaxY% = 307 AND Colum% = 3 THEN RealyExit
   
   IF KeyTrap% = 1 AND MaxY% = 331 AND Colum% = 1 THEN
    IF KeyWord$(8) = "ON" THEN Send2Lpt LineChr$(SelectedLine%)
   END IF
   IF KeyTrap% = 1 AND MaxY% = 331 AND Colum% = 2 THEN Chapter
   IF KeyTrap% = 1 AND MaxY% = 331 AND Colum% = 3 THEN Alarm VAL(KeyWord$(10))

   IF KeyTrap% = 1 THEN EXIT FOR

  NEXT Row%

 LOOP UNTIL KeyTrap% = 1

 KeyTrap% = 0

LOOP

EXIT SUB

CTheKey:

 KeyTrap% = 1

RETURN

END SUB

SUB CalcPCXDim (PcxSizeX%, PcxSizeY%)

 MinX1$ = MID$(PCXHeader, 5, 1)  '***Least Sign Byte
 MinX2$ = MID$(PCXHeader, 6, 1)  '***Most Sign Byte
 MinY1$ = MID$(PCXHeader, 7, 1)  '***Least Sign Byte
 MinY2$ = MID$(PCXHeader, 8, 1)  '***Most Sign Byte
 MaxX1$ = MID$(PCXHeader, 9, 1)  '***Least Sign Byte
 MaxX2$ = MID$(PCXHeader, 10, 1) '***Most Sign Byte
 MaxY1$ = MID$(PCXHeader, 11, 1) '***Least Sign Byte
 MaxY2$ = MID$(PCXHeader, 12, 1) '***Most Sign Byte

 '***Convert "Binary string value" to Integer
 MinX% = VAL("&H" + LTRIM$(HEX$(ASC(MinX2$))) + RIGHT$("0" + LTRIM$(HEX$(ASC(MinX1$))), 2))
 MinY% = VAL("&H" + LTRIM$(HEX$(ASC(MinY2$))) + RIGHT$("0" + LTRIM$(HEX$(ASC(MinY1$))), 2))
 MaxX% = VAL("&H" + LTRIM$(HEX$(ASC(MaxX2$))) + RIGHT$("0" + LTRIM$(HEX$(ASC(MaxX1$))), 2))
 MaxY% = VAL("&H" + LTRIM$(HEX$(ASC(MaxY2$))) + RIGHT$("0" + LTRIM$(HEX$(ASC(MaxY1$))), 2))

 '***Calc picture dim
 PcxSizeX% = MaxX% - MinX%
 PcxSizeY% = MaxY% - MinY%

END SUB

SUB Chapter

MinX% = 13
MaxX% = 34

'**erase selected page marker
OldAddX% = 0
FOR OldSelect% = 1 TO SelectedPage%
 OldAddX% = OldAddX% + 40
NEXT OldSelect%
FGboxdepth 11, 1
FGsetcolor 11
FGboxx MinX% + OldAddX% - 40, MaxX% + OldAddX% - 40, 182, 196

DO
 '**Menu
 '**Erase colum for symbol/Picture
 FGsetcolor 1
 FGrect 13, 234, 205, 404

 FGsetcolor 11
 FGboxdepth 31, 1
 FGboxx 291, 352, 205, 259

 DO
  CALL BGDELAY(time.to.wait!, time.to.go!, st%)
  FGwaitfor 1  'Slow fast machines down for keyboard "poll"
  IF INKEY$ <> "" THEN ExitLater% = 1
  JBut% = FGbutton(1)
  IF JBut% <> 0 THEN
   DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
   ExitLater% = 1
  END IF
 LOOP UNTIL st% = 0

 FGboxx 291, 352, 205, 259

 IF ExitLater% = 1 THEN
  '*****Group% = 1 ?

  '**erase selected chapter
  OldAddX% = 0
  FOR OldSelect% = 1 TO SelectedChapter%
   OldAddX% = OldAddX% + 40
  NEXT OldSelect%
  FGboxdepth 11, 1
  FGsetcolor 11
  FGboxx MinX% + OldAddX% - 40, MaxX% + OldAddX% - 40, 182, 196
  '**set selected page
  OldAddX% = 0
  FOR OldSelect% = 1 TO SelectedPage%
   OldAddX% = OldAddX% + 40
  NEXT OldSelect%
  FGboxdepth 11, 1
  FGsetcolor 11
  FGboxx MinX% + OldAddX% - 40, MaxX% + OldAddX% - 40, 182, 196
  EXIT SUB
 END IF

 AddX% = 0
' MinX% = 13
' MaxX% = 34

 FGsetcolor 11
 FGboxdepth 4, 2

 FOR Colum% = 1 TO 10

   FGsetcolor 11
   FGboxx MinX% + AddX%, MaxX% + AddX%, 182, 196

  '***set number Displayed
  IF KeyWord$(2) = "ON" THEN
   Number Colum%
   FGmove 13, 219
   R% = FGIdisplay("chapter.spr" + CHR$(0), 0, FGIHandle%)'**Load new chapter
  END IF

  DO
   CALL BGDELAY(time.to.wait!, time.to.go!, st%)
   FGwaitfor 1  'Slow fast machines down for keyboard "poll"
   IF INKEY$ <> "" THEN GOSUB ETheKey
   JBut% = FGbutton(1)
   IF JBut% <> 0 THEN
    DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
    GOSUB ETheKey
   END IF
  LOOP UNTIL st% = 0

   FGsetcolor 11
   FGboxx MinX% + AddX%, MaxX% + AddX%, 182, 196

  AddX% = AddX% + 40

  IF KeyTrap% = 1 THEN
   OldAddX% = 0
   FOR OldSelect% = 1 TO SelectedChapter%
    OldAddX% = OldAddX% + 40
   NEXT OldSelect%
   FGboxdepth 11, 1
   FGsetcolor 11
   FGboxx MinX% + OldAddX% - 40 + 1, MaxX% + OldAddX% - 40 - 1, 193, 195
   FGboxx MinX% + AddX% - 40 + 1, MaxX% + AddX% - 40 - 1, 193, 195
   OldSelectedChapter% = SelectedChapter%
   SelectedChapter% = Colum%
   IF OldSelectedChapter% <> SelectedChapter% THEN LoadChapter
   EXIT FOR
  END IF
 NEXT Colum%

 AddX% = AddX% - 40

LOOP UNTIL KeyTrap% = 1

'***Group% = 1 ?

'**set selected page
OldAddX% = 0
FOR OldSelect% = 1 TO SelectedPage%
 OldAddX% = OldAddX% + 40
NEXT OldSelect%
FGboxdepth 11, 1
FGsetcolor 11
FGboxx MinX% + OldAddX% - 40, MaxX% + OldAddX% - 40, 182, 196

EXIT SUB

ETheKey:

 KeyTrap% = 1

RETURN


END SUB

SUB check

'It takes one parameter, Dr, which is the drive number
'you wish to find the serial number of. 0=default,
'1=A:, 2=B:, 3=C: etc.
'
'NOTE:
' To use this in a program, you must have loaded
' the QB.QLB QuickLibrary (if running in the IDE)
' or link with QB.LIB (if compiling). QB.BI must
' also be available on your hard-drive.

Dr% = 1

'PRINT "The disk serial number of drive C is "; DiskSerial$(3)



'RETRIVE SERIAL NUMBER
'
READ OrgSer$
READ HexFilter$

'********
GOTO NC
'********

'**convert Hex string to ascii string
FOR N% = 1 TO LEN(HexFilter$) STEP 2
 Dummy$ = CHR$(VAL("&h" + MID$(HexFilter$, N%, 2)))
 ASCIIFilter$ = ASCIIFilter$ + Dummy$
NEXT N%

'**Filter out any chr that are not in the serial number
FOR N% = 1 TO LEN(OrgSer$)
 FOR M% = 1 TO LEN(ASCIIFilter$)
  IF MID$(OrgSer$, N%, 1) = MID$(ASCIIFilter$, M%, 1) THEN
   MID$(OrgSer$, N%, 1) = " "
  END IF
 NEXT M%
NEXT N%
OrgSer$ = RTRIM$(OrgSer$)

'Test SERIAL NUMBER
'

IF LTRIM$(RTRIM$(DiskSerial$(3))) <> OrgSer$ THEN
 IF COMMAND$ <> "TEST" THEN
  FGsetrgb 0, 0, 0, 0
  FGrect 0, 639, 0, 479
  FGsetrgb 1, 63, 0, 0
  FGsetrgb 1, 56, 0, 0
  FGsetcolor 1
  x% = 30
  Y% = -150
  FGmove x% + 95, Y% + 290: TxtFG ("                        ")
  FGmove x% + 95, Y% + 298: TxtFG ("                            ")
  FGmove x% + 95, Y% + 306: TxtFG ("                              ")
  FGmove x% + 95, Y% + 306: TxtFG ("                          ")
  FGmove x% + 95, Y% + 314: TxtFG ("                           ")
  FGmove x% + 95, Y% + 322: TxtFG ("                            ")
  FGmove x% + 95, Y% + 330: TxtFG ("                 ")
  x% = 89
  Y% = -50
  FGmove x% + 95, Y% + 290: TxtFG ("               ")
  FGmove x% + 95, Y% + 298: TxtFG ("                ")
  FGmove x% + 95, Y% + 306: TxtFG ("                  ")
  FGmove x% + 95, Y% + 306: TxtFG ("                ")
  FGmove x% + 95, Y% + 314: TxtFG ("                    ")
  FGmove x% + 95, Y% + 322: TxtFG ("                  ")
  FGmove x% + 95, Y% + 330: TxtFG ("                  ")
  Hi% = 987
  Low% = 329
  DO
   FGsetrgb 1, 63, 0, 0
   SOUND Hi%, 5
   FGsetrgb 1, 40, 0, 0
   SOUND Low%, 5
  LOOP
  SYSTEM
 ELSEIF LTRIM$(RTRIM$(DiskSerial$(3))) <> LTRIM$(RTRIM$(OrgSer$)) THEN
   SCREEN 12
   PRINT "Error"
   FGwaitkey
   SYSTEM
  ELSE
   SCREEN 12
   PRINT "Ok"
   FGwaitkey
   SYSTEM
 END IF
END IF

NC:

END SUB

REM $DYNAMIC
SUB delay (hun.scnds!) STATIC
'----------------------------------------------------------------------------
' Delay Procedure: Performs a "hard" delay.
' $MODULE: 'DELAY'
' input:  an integer representing the number of hundredth-seconds to delay
' delay == input: HUN.SCNDS! = hundredths of seconds
'----------------------------------------------------------------------------
REM'$INCLUDE: 'TICKS.def'
' Used by TIMERS to measure ticks per day
TICKS.PER.SEC! = 1193180 / 65536
SECS.PER.HR! = 60 * 60
TICKS.PER.DAY! = TICKS.PER.SEC! * SECS.PER.HR! * 24

START.TIME! = fncticks(0)                     ' mark the current time
ENDING.TIME! = fncticks(hun.scnds!)           ' mark the ending time
IF ENDING.TIME! < START.TIME! THEN
    ENDING.TIME! = ENDING.TIME! + TICKS.PER.DAY!
END IF

DO
    CURRENT.TIME! = fncticks(0)               ' mark the current time
    IF CURRENT.TIME! < START.TIME! THEN
       CURRENT.TIME! = CURRENT.TIME! + TICKS.PER.DAY!
    END IF
LOOP UNTIL CURRENT.TIME! >= ENDING.TIME!

EXIT SUB
END SUB

REM $STATIC
SUB DeleteBox

HighlightLine (SelectedLine%)

DO
  '**Menu
  '**Erase colum for symbol/Picture
  FGsetcolor 1
  FGrect 13, 234, 205, 404

  FGsetcolor 11
  FGboxdepth 31, 1
  FGboxx 291, 352, 205, 259

  DO
   CALL BGDELAY(time.to.wait!, time.to.go!, st%)
   FGwaitfor 1  'Slow fast machines down for keyboard "poll"
   IF INKEY$ <> "" THEN ExitLater% = 1
   JBut% = FGbutton(1)
   IF JBut% <> 0 THEN
    DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
    ExitLater% = 1
   END IF
  LOOP UNTIL st% = 0

  FGboxx 291, 352, 205, 259

  IF ExitLater% = 1 THEN
   HighlightLine (SelectedLine%)
   EXIT SUB
  END IF

  FGsetcolor 11
  FGboxdepth 7, 7

  FGboxx 13, 626, 414, 468

  DO
   CALL BGDELAY(time.to.wait!, time.to.go!, st%)
   FGwaitfor 1  'Slow fast machines down for keyboard "poll"
   IF INKEY$ <> "" THEN KeyTrap% = 1
   JBut% = FGbutton(1)
   IF JBut% <> 0 THEN
    DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
    KeyTrap% = 1
   END IF
  LOOP UNTIL st% = 0

  FGboxx 13, 626, 414, 468

LOOP UNTIL KeyTrap% = 1

FGsetcolor 1
FGrect 13, 626, 414, 468

HighlightLine (SelectedLine%)

FOR N% = 1 TO 6
 LineChr$(N%) = ""
NEXT N%

FOR N% = 0 TO 5
 PicturSentence$(N%) = ""
NEXT N%

END SUB

SUB DeleteLine



LineChr$(SelectedLine%) = ""


'**delete displayed string

HighlightLine (SelectedLine%)

SELECT CASE SelectedLine%
 CASE 1
  FGmove 16, 424
 CASE 2
  FGmove 16, 432
 CASE 3
  FGmove 16, 440
 CASE 4
  FGmove 16, 448
 CASE 5
  FGmove 16, 456
 CASE 6
  FGmove 16, 464
END SELECT

FGsetcolor 1
TxtFG (STRING$(76, CHR$(219)))

HighlightLine (SelectedLine%)


END SUB

DEFINT A-Z
FUNCTION DiskSerial$ (Dr AS INTEGER)

DIM RegsX AS RegTypeX
DIM A AS STRING * 25

RegsX.ax = &H6900
RegsX.bx = Dr
RegsX.ds = VARSEG(A)
RegsX.dx = VARPTR(A)
CALL InterruptX(&H21, RegsX, RegsX)

IF (RegsX.flags AND 1) = 1 THEN
  DiskSerial$ = ""
 ELSE
  A1$ = RIGHT$("0" + HEX$((ASC(MID$(A, 6)))), 2)
  A2$ = RIGHT$("0" + HEX$((ASC(MID$(A, 5)))), 2)
  A3$ = "-"
  A4$ = RIGHT$("0" + HEX$((ASC(MID$(A, 4)))), 2)
  A5$ = RIGHT$("0" + HEX$((ASC(MID$(A, 3)))), 2)
  DiskSerial$ = A1$ + A2$ + A3$ + A4$ + A5$
END IF

END FUNCTION

DEFSNG A-Z
FUNCTION GetCTS%

'*** Decode the CTS Bit of ModemReg% containing line-status
'*** register information:

ModemReg% = INP(ComPortAddr% + 6)

IF ModemReg% AND 2 ^ 4 THEN
  GetCTS% = 1
 ELSE
  GetCTS% = 0
END IF

END FUNCTION

SUB HighlightLine (LineNo%)

SELECT CASE LineNo%
 CASE 1
  MinY% = 418: MaxY% = 425
 CASE 2
  MinY% = 426: MaxY% = 433
 CASE 3
  MinY% = 434: MaxY% = 441
 CASE 4
  MinY% = 442: MaxY% = 449
 CASE 5
  MinY% = 450: MaxY% = 457
 CASE 6
  MinY% = 458: MaxY% = 465
END SELECT

'*Line
FGsetcolor 11
FGboxdepth 304, 1

FGboxx 16, 623, MinY%, MaxY%

END SUB

SUB Ini

'***splash screen

'**Set Pal to black
FGmove 0, 0
R% = FGIdisplay("black.pcx" + CHR$(0), 2, FGIHandle%)
FGsetrgb 255, 0, 0, 0

'***Windows Style Box

Lbox% = 30
Rbox% = 609
Tbox% = 100
Bbox% = 379

'***extra frame (if picture background is black)
FGsetcolor 5
FGbox Lbox%, Rbox%, Tbox%, Bbox%
'***1. frame (black)
FGsetcolor 0
FGbox Lbox% + 1, Rbox% - 1, Tbox% + 1, Bbox% - 1
'***Grey shadow
FGsetcolor 3
FGbox Lbox% + 2, Rbox% - 2, Tbox% + 2, Bbox% - 2
'***wite shadow
FGsetcolor 255
FGbox Lbox% + 2, Rbox% - 3, Tbox% + 2, Bbox% - 3
'***intenal color
FGsetcolor 5
FGrect Lbox% + 3, Rbox% - 3, Tbox% + 3, Bbox% - 3
'***Top Menu beam wite shadow
FGsetcolor 255
FGbox Lbox% + 9, Rbox% - 9, Tbox% + 7, Tbox% + 27
'***Top Menu beam grey shadow
FGsetcolor 3
FGbox Lbox% + 9, Rbox% - 10, Tbox% + 7, Tbox% + 26
'***Menu beam
FGsetcolor 0
FGrect Lbox% + 10, Rbox% - 10, Tbox% + 8, Tbox% + 26

FGsetcolor 255
FGmove 45, 119
TxtFG ("Beta 1.1 Read BSD license at the top of the source")

FGsetcolor 0
FGmove 80, 350
TxtFG ("Copyright(C)1999 - 2005 Fire Flower Cybernetics")

FGIclose FGIHandle%
GuestHandle% = FGIopen("guest.fgi" + CHR$(0))

'**Counter
FGmove 45, 370
R% = FGIdisplay("environ.spr" + CHR$(0), 0, GuestHandle%)

'***Banner
FGmove 87, 170
R% = FGIdisplay("tboard.pcx" + CHR$(0), 2, GuestHandle%)

FGIclose GuestHandle%
FGIHandle% = FGIopen("control.fgi" + CHR$(0))

FGsetcolor 35
FOR N% = 161 TO 281 STEP 10
 FGrect N%, N% + 8, 359, 364
 FGwaitfor 7
NEXT N%


'**Set Pal to black
FGmove 0, 0
R% = FGIdisplay("black.pcx" + CHR$(0), 2, FGIHandle%)
FGsetrgb 255, 0, 0, 0


'**Color to Page
FGsetcolor 1
FGrect 0, 639, 0, 479

'***Border
FGsetcolor 7
FGbox 0, 639, 0, 479
FGbox 1, 638, 1, 478
FGsetcolor 0
FGbox 2, 637, 2, 477
FGsetcolor 7
FGbox 3, 636, 3, 476

'**dictonary layout

FGmove 8, 16: TxtFG ("Ŀ")
FGmove 7, 24: TxtFG ("                                                                      ")
FGmove 8, 32: TxtFG ("Ĵ")
FGmove 7, 40: TxtFG ("                                                                      ")
FGmove 8, 48: TxtFG ("Ĵ")
FGmove 7, 56: TxtFG ("                                                                      ")
FGmove 8, 64: TxtFG ("Ĵ")
FGmove 7, 72: TxtFG ("                                                                      ")
FGmove 8, 80: TxtFG ("Ĵ")
FGmove 7, 88: TxtFG ("                                                                      ")
FGmove 8, 96: TxtFG ("Ĵ")
FGmove 7, 104: TxtFG ("                                                                      ")
FGmove 8, 112: TxtFG ("Ĵ")
FGmove 7, 120: TxtFG ("                                                                      ")
FGmove 8, 128: TxtFG ("Ĵ")
FGmove 7, 136: TxtFG ("                                                                      ")
FGmove 8, 144: TxtFG ("Ĵ")
FGmove 7, 152: TxtFG ("                                                                      ")
FGmove 8, 160: TxtFG ("Ĵ")
FGmove 7, 168: TxtFG ("                                                                      ")
FGmove 8, 176: TxtFG ("")

'**for page selector
I% = 0
FOR N% = 1 TO 10
 FGmove 8 + I%, 183: TxtFG ("Ŀ")
 FGmove 7 + I%, 191: TxtFG ("  ")
 FGmove 8 + I%, 199: TxtFG ("")
 IF N% < 10 THEN FGmove 21 + I%, 191: TxtFG (CHR$(N% + 48))
 I% = I% + 40
NEXT N%
I% = 0
FGmove 376, 191: TxtFG ("10")

'**frame for picture
FGmove 8, 206: TxtFG ("Ŀ")
FOR N% = 207 TO 395 STEP 8
 FGmove 7, N% + 6: TxtFG ("                           ")
NEXT N%
FGmove 7, 399: TxtFG ("                           ")
FGmove 8, 407: TxtFG ("")



'**14x13
'**layout for ASCII char frame (cp 850)
FGmove 400, 183: TxtFG ("Ŀ")
FOR N% = 183 TO 400 STEP 28
 FGmove 399, N% + 6: TxtFG ("              ")
 FGmove 400, N% + 14: TxtFG ("Ĵ")
 FGmove 399, N% + 20: TxtFG ("              ")
 IF N% < 360 THEN FGmove 400, N% + 28: TxtFG ("Ĵ")
NEXT N%
FGmove 400, 407: TxtFG ("")

'***Error in FG's display of frames
FGsetcolor 1
FGpoint 512, 204
FGpoint 517, 204
FGpoint 518, 204
FGsetcolor 7

'**frame for sentences
FGmove 8, 415: TxtFG ("Ŀ")
FGmove 7, 423: TxtFG ("                                                                            ")
FGmove 7, 431: TxtFG ("                                                                            ")
FGmove 7, 439: TxtFG ("                                                                            ")
FGmove 7, 447: TxtFG ("                                                                            ")
FGmove 7, 455: TxtFG ("                                                                            ")
FGmove 7, 463: TxtFG ("                                                                            ")
FGmove 8, 471: TxtFG ("")

'**Print Characters 32-255
Y% = 190
x% = 408
I% = 0
FOR N% = 32 TO 255
 FGmove x%, Y%
 TxtFG (CHR$(N%))
 x% = x% + 16
 I% = I% + 1
 IF I% = 14 THEN
  Y% = Y% + 14
  I% = 0
  x% = 408
 END IF
NEXT N%

'**frame around menu button
FGmove 286, 206: TxtFG ("Ŀ")
FGmove 285, 214: TxtFG ("       ")
FGmove 285, 222: TxtFG ("       ")
FGmove 285, 230: TxtFG ("       ")
FGmove 285, 238: TxtFG ("       ")
FGmove 285, 246: TxtFG ("       ")
FGmove 285, 254: TxtFG ("       ")
FGmove 286, 262: TxtFG ("")

'**buttons under menu
I% = 0
FOR N% = 1 TO 3
 FGmove 238 + I%, 270: TxtFG ("Ŀ")
 FGmove 237 + I%, 278: TxtFG ("     ")
 FGmove 238 + I%, 286: TxtFG ("")
 I% = I% + 54
NEXT N%

I% = 0
 FOR N% = 1 TO 3
 FGmove 238 + I%, 294: TxtFG ("Ŀ")
 FGmove 237 + I%, 302: TxtFG ("     ")
 FGmove 238 + I%, 310: TxtFG ("")
 I% = I% + 54
NEXT N%

I% = 0
 FOR N% = 1 TO 3
 FGmove 238 + I%, 318: TxtFG ("Ŀ")
 FGmove 237 + I%, 326: TxtFG ("     ")
 FGmove 238 + I%, 334: TxtFG ("")
 I% = I% + 54
NEXT N%

'**Menu button face
FGmove 293, 259: R% = FGIdisplay("mmenuf.spr" + CHR$(0), 0, FGIHandle%)

'***Button faces
FGmove 243, 283: R% = FGIdisplay("sellinf.spr" + CHR$(0), 0, FGIHandle%)'**Select line
FGmove 243, 307: R% = FGIdisplay("backspac.spr" + CHR$(0), 0, FGIHandle%)'**Backspace
FGmove 297, 283: R% = FGIdisplay("eraselin.spr" + CHR$(0), 0, FGIHandle%)'**Erase line
FGmove 297, 307: R% = FGIdisplay("sendseri.spr" + CHR$(0), 0, FGIHandle%)'**Send line serial
FGmove 351, 283: R% = FGIdisplay("delbox.spr" + CHR$(0), 0, FGIHandle%)'**Erase local line box
FGmove 351, 307: R% = FGIdisplay("exit.spr" + CHR$(0), 0, FGIHandle%)'**Exit
FGmove 243, 331: R% = FGIdisplay("locaprnt.spr" + CHR$(0), 0, FGIHandle%)'**Send to local printer
FGmove 297, 331: R% = FGIdisplay("chapter.spr" + CHR$(0), 0, FGIHandle%)'**Load new chapter
FGmove 351, 331: R% = FGIdisplay("bell.spr" + CHR$(0), 0, FGIHandle%)'**Bell

'***Button face Select line ?
FGmove 245, 278: TxtFG ("?")

'***Config file parser

'**first read keywords from DATA Structure
FOR N% = 1 TO UBOUND(KeyWord$)
 READ KeyWord$(N%)
NEXT N%

'***Exchange KeyWords with parameters
FOR N% = 1 TO UBOUND(KeyWord$)
 File% = FREEFILE
 OPEN "config.cfg" FOR INPUT AS #File%
 DO
 '***Get parameter
 LINE INPUT #File%, Dummy$
 IF KeyWord$(N%) = LTRIM$(RTRIM$(UCASE$(Dummy$))) THEN
  LINE INPUT #File%, Dummy$
  KeyWord$(N%) = LTRIM$(RTRIM$(UCASE$(Dummy$)))
  Dummy$ = ""
  EXIT DO
 END IF
 LOOP UNTIL EOF(File%)
 CLOSE #File%
NEXT N%

'***Set Parameters

'***Set Serial port
IF KeyWord$(1) = "1" OR KeyWord$(1) = "2" THEN
 ComChan% = VAL(KeyWord$(1))

 '***Set serial port speed etc. and get port adr. if serial mode = 2
 IF VAL(KeyWord$(12)) = 2 THEN
  '**The built in statments for opening the com1 and com2 seems to
  '**work fine for setting the parameters of the com so we will just
  '**use it for now (leaving the port in the new state when closed)
  ComPortHandle% = FREEFILE
  OPEN "Com" + LTRIM$(STR$(ComChan%)) + ":2400,n,8,,CS0,DS0,CD0" FOR RANDOM AS ComPortHandle%
  CLOSE ComPortHandle%
  '***Get the addr. to use for Com port
  SetCom ComChan%
 END IF
END IF

'***Set Pause
time.to.wait! = VAL(KeyWord$(5))

'***Selected line in textbox 1-6
SelectedLine% = 6

'***Load words+Pictures

NO$ = RIGHT$("0" + LTRIM$(KeyWord$(11)), 2)
SelectedChapter% = VAL(KeyWord$(11))

'*Default choice if chapter wrong
IF VAL(KeyWord$(11)) < 1 OR VAL(KeyWord$(11)) > 10 THEN
 SelectedChapter% = 1
 NO$ = RIGHT$("0" + LTRIM$(STR$(SelectedChapter%)), 2)
END IF

'** set selector of chapter
MinX% = 13
MaxX% = 34

OldAddX% = 0
FOR OldSelect% = 1 TO VAL(NO$)
 OldAddX% = OldAddX% + 40
NEXT OldSelect%
FGboxdepth 11, 1
FGsetcolor 11
FGboxx MinX% + OldAddX% - 40 + 1, MaxX% + OldAddX% - 40 - 1, 193, 195


'***Selected page in dictonary
SelectedPage% = 1

'***Highlight Selected page in dictonary
FGsetcolor 11
FGboxdepth 11, 1
FGboxx 13, 34, 182, 196

'***Load chapter
N% = 0
File% = FREEFILE
OPEN "words\chp" + NO$ + ".txt" FOR INPUT AS #File%
 DO
  LINE INPUT #File%, WordInput$
  '**Find last space to test for FileName
  WordInput$ = RTRIM$(LTRIM$(WordInput$))
  IF LEN(WordInput$) <= 1 THEN
   WordInput$ = MID$(WordInput$ + "  ", 1, 2)
  END IF
  '**test for filenames
  IF LEN(WordInput$) > 3 THEN
    Dummy$ = RIGHT$(WordInput$, 4)
   '**Look for picture name
   IF UCASE$(Dummy$) = ".SPR" OR UCASE$(Dummy$) = ".PCX" THEN CompanionType% = 1
  END IF
  '**Look for hex strings
  IF MID$(WordInput$, 1, 1) = ")" OR MID$(WordInput$, 1, 1) = "}" OR MID$(WordInput$, 1, 1) = "]" THEN CompanionType% = 2
  SELECT CASE CompanionType%
   CASE 1
    FOR I% = LEN(WordInput$) TO 1 STEP -1
     Dummy$ = MID$(WordInput$, I%, 1)
     IF Dummy$ = " " THEN EXIT FOR
     Dummy$ = ""
    NEXT I%
    TheWords$(N%) = RTRIM$(MID$(WordInput$, 1, I% - 1)) + " "
    TheCompanion$(N%) = RTRIM$(MID$(WordInput$, I% + 1, LEN(WordInput$)))
   CASE 2
    FOR I% = LEN(WordInput$) TO 1 STEP -1
     Dummy$ = MID$(WordInput$, I%, 1)
     IF Dummy$ = " " THEN EXIT FOR
     Dummy$ = ""
    NEXT I%
    TheWords$(N%) = RTRIM$(MID$(WordInput$, 1, I% - 1)) + " "
    TheCompanion$(N%) = RTRIM$(MID$(WordInput$, I% + 1, LEN(WordInput$)))
   CASE ELSE
    TheWords$(N%) = WordInput$ + " "
  END SELECT
  CompanionType% = 0
  N% = N% + 1
 LOOP UNTIL EOF(File%) OR N% > 700
CLOSE #File%

'***Print words
I% = 0
FGsetcolor 7
FOR N% = 24 TO 170 STEP 16
 FOR M% = 16 TO 544 STEP 88
  IF LEN(TheWords$(I%)) - 1 <= 10 THEN
    FGmove M%, N%: TxtFG (TheWords$(I%))
   ELSE
    IF MID$(TheWords$(I%), 1, 1) = ")" OR MID$(TheWords$(I%), 1, 1) = "}" OR MID$(TheWords$(I%), 1, 1) = "]" THEN
      FGmove M%, N%: TxtFG MID$(TheWords$(I%), 1, 10)
     ELSE
      FGmove M%, N%: TxtFG MID$(TheWords$(I%), 1, 9)
      FGmove M% + 73, N% - 6
      R% = FGIdisplay("amore.pcx" + CHR$(0), 3, FGIHandle%)
    END IF
  END IF
  I% = I% + 1
 NEXT M%
NEXT N%

'***Highlight Selected line
HighlightLine (SelectedLine%)

'***Initalize mouse if any (for break if [LOCK MENU]=On)
R% = FGmouseini
FGmouselim 1, 300, 1, 300
FGmousespd 5, 5
FGmousemov 150, 150
FGmousevis 0

'***Initalize Joystick if any
R% = FGinitjoy(1)

'***Load translation table

File% = FREEFILE
OPEN "translat.dat" FOR INPUT AS #File%
FOR N% = 0 TO 255
 LINE INPUT #File%, Dummy$
 TranslateTo%(N%) = VAL("&h" + LEFT$(Dummy$, 2))
NEXT N%
CLOSE #File%


'*** read Tonerow
FOR N% = 0 TO 14
 READ Ring1%(N%)
NEXT

FOR N% = 0 TO 15
 READ Ring2%(N%)
NEXT

FOR N% = 0 TO 15
 READ Ring3%(N%)
NEXT

FOR N% = 0 TO 15
 READ Ring4%(N%)
NEXT

'***read Hz
FOR N% = 0 TO 7
 READ RingFrekvens%(N%)
NEXT

'**Activate Cursor
WriteLine (1)



'***Show screen
FGmove 13, 205
R% = FGIdisplay("palpict.pcx" + CHR$(0), 2, FGIHandle%)

END SUB

SUB LoadChapter

'***Del Arrays
FOR N% = 0 TO 700
 TheWords$(N%) = ""
 TheCompanion$(N%) = ""
NEXT N%

'***Load words+Pictures

NO$ = RIGHT$("0" + LTRIM$(STR$(SelectedChapter%)), 2)

N% = 0
File% = FREEFILE
OPEN "words\chp" + NO$ + ".txt" FOR INPUT AS #File%
 DO
  LINE INPUT #File%, WordInput$
  '**Find last space to test for FileName
  WordInput$ = RTRIM$(LTRIM$(WordInput$))
  IF LEN(WordInput$) <= 1 THEN
   WordInput$ = MID$(WordInput$ + "  ", 1, 2)
  END IF
  '**test for filenames
  IF LEN(WordInput$) > 3 THEN
    Dummy$ = RIGHT$(WordInput$, 4)
   '**Look for picture name
   IF UCASE$(Dummy$) = ".SPR" OR UCASE$(Dummy$) = ".PCX" THEN CompanionType% = 1
  END IF
  '**Look for hex strings
  IF MID$(WordInput$, 1, 1) = ")" OR MID$(WordInput$, 1, 1) = "}" OR MID$(WordInput$, 1, 1) = "]" THEN CompanionType% = 2
  SELECT CASE CompanionType%
   CASE 1
    FOR I% = LEN(WordInput$) TO 1 STEP -1
     Dummy$ = MID$(WordInput$, I%, 1)
     IF Dummy$ = " " THEN EXIT FOR
     Dummy$ = ""
    NEXT I%
    TheWords$(N%) = RTRIM$(MID$(WordInput$, 1, I% - 1)) + " "
    TheCompanion$(N%) = RTRIM$(MID$(WordInput$, I% + 1, LEN(WordInput$)))
   CASE 2
    FOR I% = LEN(WordInput$) TO 1 STEP -1
     Dummy$ = MID$(WordInput$, I%, 1)
     IF Dummy$ = " " THEN EXIT FOR
     Dummy$ = ""
    NEXT I%
    TheWords$(N%) = RTRIM$(MID$(WordInput$, 1, I% - 1)) + " "
    TheCompanion$(N%) = RTRIM$(MID$(WordInput$, I% + 1, LEN(WordInput$)))
   CASE ELSE
    TheWords$(N%) = WordInput$ + " "
  END SELECT
  CompanionType% = 0
  N% = N% + 1
 LOOP UNTIL EOF(File%) OR N% > 700
CLOSE #File%

'***Display Page in New Chapter
LoadPage

END SUB

SUB LoadPage

'***Delete words on screen
MinX% = 13
MaxX% = 98
MinY% = 15
MaxY% = 29

FGsetcolor 1

FOR N% = 1 TO 10
 FOR M% = 1 TO 7
  FGrect MinX% + AddX%, MaxX% + AddX%, MinY% + AddY%, MaxY% + AddY%
  AddX% = AddX% + 88
 NEXT M%
 AddX% = 0
 AddY% = AddY% + 16
NEXT N%

NewPage% = (SelectedPage% - 1) * 70

FGsetcolor 7

'***Print words
I% = 0
FOR N% = 24 TO 170 STEP 16
 FOR M% = 16 TO 544 STEP 88
  IF LEN(TheWords$(I% + NewPage%)) - 1 <= 10 THEN
    FGmove M%, N%: TxtFG (TheWords$(I% + NewPage%))
   ELSE
    IF MID$(TheWords$(I% + NewPage%), 1, 1) = ")" OR MID$(TheWords$(I% + NewPage%), 1, 1) = "}" OR MID$(TheWords$(I% + NewPage%), 1, 1) = "]" THEN
      FGmove M%, N%: TxtFG MID$(TheWords$(I% + NewPage%), 1, 10)
     ELSE
      FGmove M%, N%: TxtFG MID$(TheWords$(I% + NewPage%), 1, 9)
      FGmove M% + 73, N% - 6
      R% = FGIdisplay("amore.pcx" + CHR$(0), 2, FGIHandle%)
    END IF
  END IF
  I% = I% + 1
 NEXT M%
NEXT N%


END SUB

SUB Menu

'**Erase any symbol or Pic
FGsetcolor 1
FGrect 13, 234, 205, 404

DO

 '**add Choice
 Choice% = Choice% + 1
 IF Choice% > 5 THEN Choice% = 1

 SELECT CASE Choice%

  CASE 1
   '**Word
   Group% = 2
   FGsetcolor 11
   'FGboxdepth 307, 1
   FGboxdepth 7, 7
   FGboxx 13, 626, 15, 173
   DO
    CALL BGDELAY(time.to.wait!, time.to.go!, st%)
    IF INKEY$ <> "" THEN
     ExitLater% = 1
    END IF
    JBut% = FGbutton(1)
    IF JBut% <> 0 THEN
     DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
     ExitLater% = 1
    END IF
   LOOP UNTIL st% = 0
   FGsetcolor 11
   FGboxdepth 7, 7
   FGboxx 13, 626, 15, 173
   
  CASE 2 '**Alfa
   Group% = 3
   FGsetcolor 11
   'FGboxdepth 111, 1
   FGboxdepth 7, 7
   FGboxx 405, 626, 182, 404
   DO
    CALL BGDELAY(time.to.wait!, time.to.go!, st%)
    FGwaitfor 1  'Slow fast machines down for keyboard "poll"
    IF INKEY$ <> "" THEN
     ExitLater% = 1
    END IF
    JBut% = FGbutton(1)
    IF JBut% <> 0 THEN
     DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
     ExitLater% = 1
    END IF
   LOOP UNTIL st% = 0
   FGsetcolor 11
   FGboxdepth 7, 7
   FGboxx 405, 626, 182, 404

  CASE 3 '**buttons
   Group% = 4
   FGsetcolor 11
   'FGboxdepth 111, 1
   FGboxdepth 7, 7
   FGboxx 243, 396, 269, 331
   DO
    CALL BGDELAY(time.to.wait!, time.to.go!, st%)
    FGwaitfor 1  'Slow fast machines down for keyboard "poll"
    IF INKEY$ <> "" THEN
     ExitLater% = 1
    END IF
    JBut% = FGbutton(1)
    IF JBut% <> 0 THEN
     DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
     ExitLater% = 1
    END IF
   LOOP UNTIL st% = 0
   FGsetcolor 11
   FGboxdepth 7, 7
   FGboxx 243, 396, 269, 331

  CASE 4 '**Picture
   Group% = 5
   FGsetcolor 11
   'FGboxdepth 191, 1
   FGboxdepth 7, 7
   FGboxx 13, 234, 205, 404
   DO
    CALL BGDELAY(time.to.wait!, time.to.go!, st%)
    FGwaitfor 1  'Slow fast machines down for keyboard "poll"
    IF INKEY$ <> "" THEN
     ExitLater% = 1
    END IF
    JBut% = FGbutton(1)
    IF JBut% <> 0 THEN
     DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
     ExitLater% = 1
    END IF
   LOOP UNTIL st% = 0
   FGsetcolor 11
   FGboxdepth 7, 7
   FGboxx 13, 234, 205, 404

  CASE 5 '**Page
   Group% = 6
   FGsetcolor 11
   'FGboxdepth 191, 1
   FGboxdepth 7, 3
   FGboxx 13, 394, 182, 196
   DO
    CALL BGDELAY(time.to.wait!, time.to.go!, st%)
    FGwaitfor 1  'Slow fast machines down for keyboard "poll"
    IF INKEY$ <> "" THEN
     ExitLater% = 1
    END IF
    JBut% = FGbutton(1)
    IF JBut% <> 0 THEN
     DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
     ExitLater% = 1
    END IF
   LOOP UNTIL st% = 0
   FGsetcolor 11
   FGboxdepth 7, 3
   FGboxx 13, 394, 182, 196

 END SELECT


LOOP UNTIL ExitLater% = 1

END SUB

SUB Number (NO%)

FGsetcolor 1
FGrect 13, 234, 205, 404

SELECT CASE NO%

 CASE 0
  FGsetcolor 7
  FGmove 95, 290: TxtFG ("")
  FGmove 95, 298: TxtFG ("   ")
  FGmove 95, 306: TxtFG ("   ")
  FGmove 95, 314: TxtFG ("   ")
  FGmove 95, 322: TxtFG ("")
  FGsetcolor 1
  FGmove 128, 307: FGdraw 134, 307


 CASE 1
  FGsetcolor 7
  FGmove 95, 290: TxtFG ("    ")
  FGmove 95, 298: TxtFG ("     ")
  FGmove 95, 306: TxtFG ("     ")
  FGmove 95, 314: TxtFG ("     ")
  FGmove 95, 322: TxtFG ("     ")
  FGsetcolor 1
  FGmove 128, 307: FGdraw 134, 307

 CASE 2
  FGsetcolor 7
  FGmove 95, 290: TxtFG ("")
  FGmove 95, 298: TxtFG ("     ")
  FGmove 95, 306: TxtFG ("")
  FGmove 95, 314: TxtFG ("")
  FGmove 95, 322: TxtFG ("")
  FGmove 129, 307: FGdraw 130, 307

 CASE 3
  FGsetcolor 7
  FGmove 95, 290: TxtFG ("")
  FGmove 95, 298: TxtFG ("     ")
  FGmove 95, 306: TxtFG ("")
  FGmove 95, 314: TxtFG ("     ")
  FGmove 95, 322: TxtFG ("")
  FGmove 129, 307: FGdraw 130, 307

 CASE 4
  FGsetcolor 7
  FGmove 95, 290: TxtFG ("   ")
  FGmove 95, 298: TxtFG ("   ")
  FGmove 95, 306: TxtFG ("")
  FGmove 95, 314: TxtFG ("     ")
  FGmove 95, 322: TxtFG ("     ")
  FGmove 129, 307: FGdraw 130, 307

 CASE 5
  FGsetcolor 7
  FGmove 95, 290: TxtFG ("")
  FGmove 95, 298: TxtFG ("")
  FGmove 95, 306: TxtFG ("")
  FGmove 95, 314: TxtFG ("     ")
  FGmove 95, 322: TxtFG ("")
  FGmove 129, 307: FGdraw 130, 307

 CASE 6
  FGsetcolor 7
  FGmove 95, 290: TxtFG ("")
  FGmove 95, 298: TxtFG ("")
  FGmove 95, 306: TxtFG ("")
  FGmove 95, 314: TxtFG ("   ")
  FGmove 95, 322: TxtFG ("")
  FGmove 129, 307: FGdraw 130, 307

 CASE 7
  FGsetcolor 7
  FGmove 95, 290: TxtFG ("")
  FGmove 95, 298: TxtFG ("     ")
  FGmove 95, 306: TxtFG ("     ")
  FGmove 95, 314: TxtFG ("     ")
  FGmove 95, 322: TxtFG ("     ")
  FGsetcolor 1
  FGmove 128, 307: FGdraw 134, 307

 CASE 8
  FGsetcolor 7
  FGmove 95, 290: TxtFG ("")
  FGmove 95, 298: TxtFG ("   ")
  FGmove 95, 306: TxtFG ("")
  FGmove 95, 314: TxtFG ("   ")
  FGmove 95, 322: TxtFG ("")
  FGmove 129, 307: FGdraw 130, 307

 CASE 9
  FGsetcolor 7
  FGmove 95, 290: TxtFG ("")
  FGmove 95, 298: TxtFG ("   ")
  FGmove 95, 306: TxtFG ("")
  FGmove 95, 314: TxtFG ("     ")
  FGmove 95, 322: TxtFG ("")
  FGmove 129, 307: FGdraw 130, 307

 CASE 10
  FGsetcolor 7
  FGmove 75, 290: TxtFG ("  ")
  FGmove 75, 298: TxtFG ("      ")
  FGmove 75, 306: TxtFG ("      ")
  FGmove 75, 314: TxtFG ("      ")
  FGmove 75, 322: TxtFG ("   ")

 CASE 11
  FGsetcolor 7
  FGmove 75, 290: TxtFG ("      ")
  FGmove 75, 298: TxtFG ("        ")
  FGmove 75, 306: TxtFG ("        ")
  FGmove 75, 314: TxtFG ("        ")
  FGmove 75, 322: TxtFG ("        ")
  FGsetcolor 1
  FGmove 128, 307: FGdraw 130, 307

 CASE 12
  FGsetcolor 7
  FGmove 75, 290: TxtFG ("  ")
  FGmove 75, 298: TxtFG ("        ")
  FGmove 75, 306: TxtFG ("   ")
  FGmove 75, 314: TxtFG ("   ")
  FGmove 75, 322: TxtFG ("   ")

 CASE 13
  FGsetcolor 7
  FGmove 75, 290: TxtFG ("  ")
  FGmove 75, 298: TxtFG ("        ")
  FGmove 75, 306: TxtFG ("   ")
  FGmove 75, 314: TxtFG ("        ")
  FGmove 75, 322: TxtFG ("   ")

 CASE 14
  FGsetcolor 7
  FGmove 75, 290: TxtFG ("     ")
  FGmove 75, 298: TxtFG ("      ")
  FGmove 75, 306: TxtFG ("   ")
  FGmove 75, 314: TxtFG ("        ")
  FGmove 75, 322: TxtFG ("        ")

 CASE 15
  FGsetcolor 7
  FGmove 75, 290: TxtFG ("  ")
  FGmove 75, 298: TxtFG ("   ")
  FGmove 75, 306: TxtFG ("   ")
  FGmove 75, 314: TxtFG ("        ")
  FGmove 75, 322: TxtFG ("   ")

END SELECT

END SUB

SUB Page

DO
 '**Menu
 '**Erase colum for symbol/Picture
 FGsetcolor 1
 FGrect 13, 234, 205, 404

 FGsetcolor 11
 FGboxdepth 31, 1
 FGboxx 291, 352, 205, 259

 DO
  CALL BGDELAY(time.to.wait!, time.to.go!, st%)
  FGwaitfor 1  'Slow fast machines down for keyboard "poll"
  IF INKEY$ <> "" THEN ExitLater% = 1
  JBut% = FGbutton(1)
  IF JBut% <> 0 THEN
   DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
   ExitLater% = 1
  END IF
 LOOP UNTIL st% = 0

 FGboxx 291, 352, 205, 259
	      '**
 IF ExitLater% = 1 THEN
  Group% = 1
  EXIT SUB
 END IF

 AddX% = 0
 MinX% = 13
 MaxX% = 34

 FGsetcolor 11
 FGboxdepth 4, 2

 FOR Colum% = 1 TO 10

   FGsetcolor 11
   FGboxx MinX% + AddX%, MaxX% + AddX%, 182, 196

  '***set number Displayed
  IF KeyWord$(2) = "ON" THEN
   Number Colum%
  END IF

  DO
   CALL BGDELAY(time.to.wait!, time.to.go!, st%)
   FGwaitfor 1  'Slow fast machines down for keyboard "poll"
   IF INKEY$ <> "" THEN GOSUB BTheKey
   JBut% = FGbutton(1)
   IF JBut% <> 0 THEN
    DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
    GOSUB BTheKey
   END IF
  LOOP UNTIL st% = 0

   FGsetcolor 11
   FGboxx MinX% + AddX%, MaxX% + AddX%, 182, 196

  AddX% = AddX% + 40
  
  IF KeyTrap% = 1 THEN
   OldAddX% = 0
   FOR OldSelect% = 1 TO SelectedPage%
    OldAddX% = OldAddX% + 40
   NEXT OldSelect%
   FGboxdepth 11, 1
   FGsetcolor 11
   FGboxx MinX% + OldAddX% - 40, MaxX% + OldAddX% - 40, 182, 196
   FGboxx MinX% + AddX% - 40, MaxX% + AddX% - 40, 182, 196
   SelectedPage% = Colum%
   LoadPage
   EXIT FOR
  END IF
 NEXT Colum%

 AddX% = AddX% - 40

LOOP UNTIL KeyTrap% = 1

Group% = 1

EXIT SUB

BTheKey:

 KeyTrap% = 1

RETURN

END SUB

SUB Paste2Line (ChrOrStr$, ArrNo%)

'***Test is Alfa the caller
A% = 0
IF ArrNo% = 32767 THEN
 A% = 1
 ArrNo% = 0
END IF

'***Is the string a local macro
 IF MID$(ChrOrStr$, 1, 1) = ")" THEN '**It's a local macro
  HexString$ = TheCompanion$(ArrNo%)
  '***Convert to chr's
  FOR N% = 1 TO LEN(HexString$) STEP 2
   A$ = A$ + CHR$(VAL("&h" + MID$(HexString$, N%, 2)))
  NEXT N%
  '**see if string is to big to fit textbox and if not Add it to LineChr$()
  IF LEN(A$ + LineChr$(SelectedLine%)) < 77 THEN
    LineChr$(SelectedLine%) = LineChr$(SelectedLine%) + A$

    '**add picture if any
    IF LEN(TheCompanion$(ArrNo%)) <> 0 THEN
      PicturSentence$(SelectedLine% - 1) = PicturSentence$(SelectedLine% - 1) + "[)" + TheCompanion$(ArrNo%) + TheWords$(ArrNo%)
     ELSE
      PicturSentence$(SelectedLine% - 1) = PicturSentence$(SelectedLine% - 1) + "(]" + TheWords$(ArrNo%)
    END IF

   ELSE
    ChrOrStr$ = A$
    GOSUB ForcedScroll
  END IF
 ELSEIF MID$(ChrOrStr$, 1, 1) = "}" THEN '**It's a remote macro
  HexString$ = TheCompanion$(ArrNo%)
  '***Convert to chr's
  FOR N% = 1 TO LEN(HexString$) STEP 2
   A$ = A$ + CHR$(VAL("&h" + MID$(HexString$, N%, 2)))
  NEXT N%
  IF ComChan% <> 0 THEN SendSerial A$
  EXIT SUB
 ELSEIF MID$(ChrOrStr$, 1, 1) = "]" THEN '**It's a local Lprint macro
  HexString$ = TheCompanion$(ArrNo%)
  '***Convert to chr's
  FOR N% = 1 TO LEN(HexString$) STEP 2
   A$ = A$ + CHR$(VAL("&h" + MID$(HexString$, N%, 2)))
  NEXT N%
  IF KeyWord$(8) = "ON" THEN Send2Lpt A$
  EXIT SUB
 ELSE '**ordinary text
  A$ = LineChr$(SelectedLine%)
  A$ = A$ + ChrOrStr$
  '**see if string is to big to fit textbox and if not Add it to LineChr$()
  IF LEN(A$) < 77 THEN

    
    '***s Are the user using a word to add to letters?
    Look4Alpha$ = RIGHT$(PicturSentence$(SelectedLine% - 1), 3)

    '**rewrite s
    IF LEFT$(Look4Alpha$, 2) <> "{]" OR Look4Alpha$ = "{] " THEN
      LineChr$(SelectedLine%) = A$
     ELSE
      LineChr$(SelectedLine%) = LTRIM$(RTRIM$(A$))
    END IF
    '**rewrite e

    '**add picture if any
    IF A% = 0 THEN

     IF LEFT$(Look4Alpha$, 2) <> "{]" OR Look4Alpha$ = "{] " THEN
      IF Look4Alpha$ = "{] " THEN PicturSentence$(SelectedLine% - 1) = PicturSentence$(SelectedLine% - 1) + " "
     '**e

       IF LEN(TheCompanion$(ArrNo%)) <> 0 THEN
	 PicturSentence$(SelectedLine% - 1) = PicturSentence$(SelectedLine% - 1) + "[)" + TheCompanion$(ArrNo%) + TheWords$(ArrNo%)
	ELSE
	 PicturSentence$(SelectedLine% - 1) = PicturSentence$(SelectedLine% - 1) + "(]" + TheWords$(ArrNo%)
       END IF

      ELSE '***s conv. word to letters
	EditString$ = RTRIM$(TheWords$(ArrNo%))
	NewStringEnd$ = ""
	FOR LetterMaker% = 1 TO LEN(EditString$)
	 NewStringEnd$ = NewStringEnd$ + "{]" + MID$(EditString$, LetterMaker%, 1)
	NEXT LetterMaker%
	PicturSentence$(SelectedLine% - 1) = PicturSentence$(SelectedLine% - 1) + NewStringEnd$

FGsetcolor 0
FGrect 0, 639, 0, 28
FGsetcolor 11
FGlocate 0, 0
FGtext PicturSentence$(SelectedLine% - 1) + "", LEN(PicturSentence$(SelectedLine% - 1)) + 1

     END IF'**e
     
    ELSE
     '**Add singel chr without picture
     PicturSentence$(SelectedLine% - 1) = PicturSentence$(SelectedLine% - 1) + "{]" + ChrOrStr$
    END IF
   ELSE
    GOSUB ForcedScroll
  END IF
 END IF

'**Display string
WriteLine (1)

EXIT SUB

ForcedScroll:

IF SelectedLine% = 6 THEN '***Forced Scroll

  '**scroll the array of the picturenames/single chr/words -pictures
  PicturSentence$(0) = PicturSentence$(1)
  PicturSentence$(1) = PicturSentence$(2)
  PicturSentence$(2) = PicturSentence$(3)
  PicturSentence$(3) = PicturSentence$(4)
  PicturSentence$(4) = PicturSentence$(5)
  IF A% <> 0 THEN
    PicturSentence$(5) = "{]" + ChrOrStr$
   ELSE
    IF LEN(TheCompanion$(ArrNo%)) <> 0 THEN
      PicturSentence$(5) = "[)" + TheCompanion$(ArrNo%) + TheWords$(ArrNo%)
     ELSE
      PicturSentence$(5) = "(]" + TheWords$(ArrNo%)
    END IF
  END IF

  '**scroll the array of text lines
  LineChr$(1) = LineChr$(2)
  LineChr$(2) = LineChr$(3)
  LineChr$(3) = LineChr$(4)
  LineChr$(4) = LineChr$(5)
  LineChr$(5) = LineChr$(6)
  LineChr$(6) = ChrOrStr$

  '**redisplay scrolled lines on screen
  FGsetcolor 1
  FGrect 13, 626, 414, 468
  FGsetcolor 7
  FGmove 16, 424: TxtFG (LineChr$(1))
  FGmove 16, 432: TxtFG (LineChr$(2))
  FGmove 16, 440: TxtFG (LineChr$(3))
  FGmove 16, 448: TxtFG (LineChr$(4))
  FGmove 16, 456: TxtFG (LineChr$(5))
  FGmove 16, 464: TxtFG (LineChr$(6))
  HighlightLine (SelectedLine%)
 ELSE
  '***To many chr's
  FGmove 13, 404
  R% = FGIdisplay("lerr.spr" + CHR$(0), 0, FGIHandle%)
  FOR N% = 0 TO 66
   SOUND 100, .1
   SOUND 104, .1
  NEXT N%
END IF

RETURN

END SUB

SUB Picture

'**Analyze string for Pictures+Words+Letters
'

N% = 1
DO
 
 IF LEN(PicturSentence$(SelectedLine% - 1)) = 0 THEN EXIT DO
 '***let's look for pictures and picturenames
 '**first we make sure there is any space left in string for marker
 IF LEN(PicturSentence$(SelectedLine% - 1)) >= N% + 1 THEN
  IF MID$(PicturSentence$(SelectedLine% - 1), N%, 2) = "[)" THEN
    N% = N% + 2

    FOR M% = N% TO LEN(PicturSentence$(SelectedLine% - 1))

     IF UCASE$(MID$(PicturSentence$(SelectedLine% - 1), M%, 4)) = ".SPR" OR UCASE$(MID$(PicturSentence$(SelectedLine% - 1), M%, 4)) = ".PCX" THEN
       P$ = P$ + MID$(PicturSentence$(SelectedLine% - 1), M%, 4)
       '**retrive word part
       W% = M% + 4
       DO
	IF LEN(PicturSentence$(SelectedLine% - 1)) >= W% + 1 THEN
	  IF MID$(PicturSentence$(SelectedLine% - 1), W%, 2) = "[)" OR MID$(PicturSentence$(SelectedLine% - 1), W%, 2) = "(]" OR MID$(PicturSentence$(SelectedLine% - 1), W%, 2) = "{]" THEN
	   EXIT DO
	  END IF
	END IF
	'**get chr
	W$ = W$ + MID$(PicturSentence$(SelectedLine% - 1), W%, 1)
	W% = W% + 1
       '**get last chr
       IF W% = LEN(PicturSentence$(SelectedLine% - 1)) THEN
	W$ = W$ + MID$(PicturSentence$(SelectedLine% - 1), W%, 1)
       END IF
       LOOP UNTIL W% = LEN(PicturSentence$(SelectedLine% - 1))
       '***gosub display picture: exit for
       GOSUB DisplayPictures
       P$ = ""
       W$ = ""
       EXIT FOR
      ELSE
       P$ = P$ + MID$(PicturSentence$(SelectedLine% - 1), M%, 1)
     END IF
    NEXT M%
   ELSEIF MID$(PicturSentence$(SelectedLine% - 1), N%, 2) = "(]" THEN
   '**go looking for word without picture "(]"
    FOR M% = N% + 2 TO LEN(PicturSentence$(SelectedLine% - 1))
     IF LEN(PicturSentence$(SelectedLine% - 1)) >= M% + 1 THEN
      IF MID$(PicturSentence$(SelectedLine% - 1), M%, 2) = "[)" OR MID$(PicturSentence$(SelectedLine% - 1), M%, 2) = "(]" OR MID$(PicturSentence$(SelectedLine% - 1), M%, 2) = "{]" THEN
       EXIT FOR
      END IF
     END IF
     W$ = W$ + MID$(PicturSentence$(SelectedLine% - 1), M%, 1)
    NEXT M%
    GOSUB DisplayWord
    W$ = ""
   ELSEIF MID$(PicturSentence$(SelectedLine% - 1), N%, 2) = "{]" THEN
   '**It's a single chr enlarge it and display
    GOSUB ZoomLetter
  END IF
 END IF
 N% = N% + 1
LOOP UNTIL N% >= LEN(PicturSentence$(SelectedLine% - 1))


Group% = 1


EXIT SUB

'*Show words
'

DisplayWord:

'**erase display
FGsetcolor 1
FGrect 13, 234, 205, 404

SubTitle (W$)

SLEEP 1

RETURN

'*Show Pictures and words
'

DisplayPictures:

'**standard pixel run ???
IF UCASE$(RIGHT$(P$, 4)) = ".SPR" THEN
 '**load pallet pcx
 '
 FGmove 13, 205
 R% = FGIdisplay("palpict.pcx" + CHR$(0), 2, FGIHandle%)

 '**Erase colum for symbol
 FGsetcolor 0
 FGrect 13, 234, 205, 404

 '**load standard pixel run
 '
 FGmove 13, 404
 R% = FGIdisplay(P$ + CHR$(0), 0, PictoHandle%)

 ELSE


 '**Erase colum for symbol
 FGsetcolor 1
 FGrect 13, 234, 205, 404

 '**See if it is a pcx file and retrive header
 S% = FGpcxhead("images\" + P$ + CHR$(0), PCXHeader)

 '***If it is a pcx go on
 IF S% = 0 THEN

  '**get dimension of picture window
  CalcPCXDim PcxSizeX%, PcxSizeY%

  '***now lets retrive the pal part of the file
  File% = FREEFILE
  OPEN "images\" + P$ FOR BINARY AS #File%
   LenghtOfFile& = LOF(File%)
   '**Go to the end of the file and load the Pal
   PalStart& = LenghtOfFile& - 768
   PCXPal$ = SPACE$(768)
   GET #File%, PalStart&, PCXPal$
  CLOSE #File%

  '***if it's 256 col. then go ahead
  IF MID$(PCXPal$, 1, 1) = CHR$(12) THEN

   '***Compare program reserved colors with pcx files  RGB
   IF MID$(PCXPal$, 2, 3) = CHR$(0) + CHR$(0) + CHR$(0) THEN '*col 0
    IF MID$(PCXPal$, 5, 3) = CHR$(0) + CHR$(0) + CHR$(171) THEN '*col 1
     IF MID$(PCXPal$, 23, 3) = CHR$(171) + CHR$(171) + CHR$(171) THEN '*col 7
      IF MID$(PCXPal$, 32, 3) = CHR$(87) + CHR$(255) + CHR$(87) THEN '*col 10
       IF MID$(PCXPal$, 35, 3) = CHR$(87) + CHR$(255) + CHR$(255) THEN '*col 11
	IF MID$(PCXPal$, 38, 3) = CHR$(255) + CHR$(87) + CHR$(87) THEN '*col 12
	 colors% = 1
	END IF
       END IF
      END IF
     END IF
    END IF
   END IF

   IF colors% = 1 THEN '*Color RGB test = true
    colors% = 0

    '***see if the picture will fit, if so load
    IF PcxSizeX% <= 221 THEN
      IF PcxSizeY% <= 199 THEN
	FGmove 13, 205
	'***set Picture Displayed
	 R% = FGshowpcx("images\" + P$ + CHR$(0), 2)
       ELSE
	'**Erase any picture
	FGsetcolor 1
	FGrect 13, 234, 205, 404
	FGsetcolor 7
	FGmove 16, 216
	TxtFG ("ERROR Picture to big to fit")
	FGmove 16, 232
	TxtFG ("Picture Name:" + P$)
	FGwaitfor 90
	'**Erase text
	FGsetcolor 1
	FGrect 13, 234, 205, 404
      END IF '*end for is Y size to big
     ELSE
       '**Erase any picture
       FGsetcolor 1
       FGrect 13, 234, 205, 404
       FGsetcolor 7
       FGmove 16, 216
       TxtFG ("ERROR Picture to big to fit")
       FGmove 16, 232
       TxtFG ("Picture Name:" + P$)
       FGwaitfor 90
       '**Erase text
       FGsetcolor 1
       FGrect 13, 234, 205, 404
     END IF '*end for is X size to big
   ELSE
     '**Erase any picture
     FGsetcolor 1
     FGrect 13, 234, 205, 404
     FGsetcolor 7
     FGmove 16, 216
     TxtFG ("ERROR This picture is using")
     FGmove 16, 232
     TxtFG ("program reserved colors")
     FGmove 16, 248
     TxtFG ("with wrong RGB settings")
     FGmove 16, 264
     TxtFG ("if problem persist try to")
     FGmove 16, 280
     TxtFG ("use the FORCEPAL.EXE")
     FGmove 16, 296
     TxtFG ("utility")
     FGmove 16, 312
     TxtFG ("file name:" + P$)
     FGwaitfor 144
     '**Erase text
     FGsetcolor 1
     FGrect 13, 234, 205, 404
   END IF '*Color RGB test = true
   ELSE
     '**Erase any picture
     FGsetcolor 1
     FGrect 13, 234, 205, 404
     FGsetcolor 7
     FGmove 16, 216
     TxtFG ("ERROR This file is not")
     FGmove 16, 232
     TxtFG ("recognized as a 256 color")
     FGmove 16, 248
     TxtFG ("PCX File")
     FGmove 16, 264
     TxtFG ("file name:" + P$)
     FGwaitfor 90
     '**Erase text
     FGsetcolor 1
     FGrect 13, 234, 205, 404
  END IF '*(is it 256 col. then go ahead)
  ELSE
   '**Make sure it's not a macro
   Test4macro$ = P$
   Test4PCX$ = TheCompanion$(Colum% + ((Row% * 7) - 7) - 1 + (SelectedPage% - 1) * 70)
   IF MID$(Test4macro$, 1, 1) <> ")" AND MID$(Test4macro$, 1, 1) <> "}" AND MID$(Test4macro$, 1, 1) <> "]" AND LEN(Test4PCX$) <> 0 THEN
    '**Erase any picture
    FGsetcolor 1
    FGrect 13, 234, 205, 404
    FGsetcolor 7
    FGmove 16, 216
    TxtFG ("ERROR This file is not")
    FGmove 16, 232
    TxtFG ("recognized as a graphical")
    FGmove 16, 248
    TxtFG ("PCX File")
    FGmove 16, 264
    TxtFG ("file name:" + P$)
    FGwaitfor 90
    '**Erase text
    FGsetcolor 1
    FGrect 13, 234, 205, 404
   END IF
 END IF '**If it is a pcx go on

END IF '**standard pixel run ???

SubTitle (W$)

SLEEP 1

RETURN


ZoomLetter:

'Extract ASCII No. of letter from string
Z% = ASC(MID$(PicturSentence$(SelectedLine% - 1), N% + 2, 1))

MinX% = 405
MinY% = 182
L% = 31

'***Find coordinates for reading letter of screen
FOR I% = 1 TO 16
 FOR O% = 1 TO 14
  L% = L% + 1
  IF L% = Z% THEN EXIT FOR
  MinX% = MinX% + 16
 NEXT O%
 IF L% = Z% THEN EXIT FOR
 MinY% = MinY% + 14
 MinX% = 405
NEXT I%

'***Erase before displaying enlarged letter
FGsetcolor 1
FGrect 13, 234, 205, 404

'***Enlarge character
BigX% = 66: BigY% = 250
FOR I% = MinY% TO MinY% + 12
 FOR O% = MinX% TO MinX% + 13
  col% = FGgetpixel(O%, I%)
  IF col% = 1 THEN
    FGsetcolor 1
   ELSE
    FGsetcolor 7
  END IF
  FGmove BigX%, BigY%
  FGrect BigX%, BigX% + 8, BigY%, BigY% + 8
  BigX% = BigX% + 8
 NEXT O%
 BigY% = BigY% + 8
 BigX% = 66
NEXT I%

SLEEP 1

RETURN

END SUB

SUB RealyExit

DO
  '**Menu
  '**Erase colum for symbol/Picture
  FGsetcolor 1
  FGrect 13, 234, 205, 404

  FGsetcolor 11
  FGboxdepth 31, 1
  FGboxx 291, 352, 205, 259

  DO
   CALL BGDELAY(time.to.wait!, time.to.go!, st%)
   FGwaitfor 1  'Slow fast machines down for keyboard "poll"
   IF INKEY$ <> "" THEN ExitLater% = 1
   JBut% = FGbutton(1)
   IF JBut% <> 0 THEN
    DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
    ExitLater% = 1
   END IF
  LOOP UNTIL st% = 0

  FGboxx 291, 352, 205, 259

  IF ExitLater% = 1 THEN
   EXIT SUB
  END IF

  FGsetcolor 11
  FGboxdepth 23, 1

  FGboxx 351, 396, 293, 307

  DO
   CALL BGDELAY(time.to.wait!, time.to.go!, st%)
   FGwaitfor 1  'Slow fast machines down for keyboard "poll"
   IF INKEY$ <> "" THEN
    '**Set Pal to black
    FGmove 0, 0
    R% = FGIdisplay("black.pcx" + CHR$(0), 2, FGIHandle%)
    FGsetrgb 255, 0, 0, 0
    FGmove 0, 0
    R% = FGIdisplay("donate.pcx" + CHR$(0), 3, FGIHandle%)
    FGmove 0, 0
    R% = FGIdisplay("donon.pcx" + CHR$(0), 2, FGIHandle%)
    SLEEP 5
    Heap& = SETMEM(-5000)
    FGIclose PictoHandle%
    FGIclose FGIHandle%
    SCREEN 12
    SYSTEM
   END IF
   JBut% = FGbutton(1)
   IF JBut% <> 0 THEN
    DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
    '**Set Pal to black
    FGmove 0, 0
    R% = FGIdisplay("black.pcx" + CHR$(0), 2, FGIHandle%)
    FGsetrgb 255, 0, 0, 0
    FGmove 0, 0
    R% = FGIdisplay("donate.pcx" + CHR$(0), 3, FGIHandle%)
    FGmove 0, 0
    R% = FGIdisplay("donon.pcx" + CHR$(0), 2, FGIHandle%)
    SLEEP 5
    Heap& = SETMEM(-5000)
    FGIclose PictoHandle%
    FGIclose FGIHandle%
    SCREEN 12
    SYSTEM
   END IF
  LOOP UNTIL st% = 0

  FGboxx 351, 396, 293, 307

LOOP

END SUB

SUB RTS (State%)

' This sub toggles RTS of the RS-232 serial communications line on and off
'
' The RTS line is controlled by the second
' bit in the modem control register.

'***Sets second bit to turn on RTS.
IF State% = 1 THEN
 OUT ComPortAddr% + 4, INP(ComPortAddr% + 4) OR 2
END IF

'***Clears second bit to turn off RTS
IF State% = 0 THEN
 OUT ComPortAddr% + 4, INP(ComPortAddr% + 4) AND &HFD
END IF

END SUB

SUB SelectLine

'**Erase colum for symbol/Picture
FGsetcolor 1
FGrect 13, 234, 205, 404

'**Erase cursor
WriteLine (0)

'***Deselect selected Line
Row% = SelectedLine%
GOSUB LineSelecter
Row% = 0

DO

 '**Menu

 FGsetcolor 11
 FGboxdepth 31, 1
 FGboxx 291, 352, 205, 259

 DO
  CALL BGDELAY(time.to.wait!, time.to.go!, st%)
  FGwaitfor 1  'Slow fast machines down for keyboard "poll"
  IF INKEY$ <> "" THEN ExitLater% = 1
  JBut% = FGbutton(1)
  IF JBut% <> 0 THEN
   DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
   ExitLater% = 1
  END IF
 LOOP UNTIL st% = 0

 FGboxx 291, 352, 205, 259
	      '**
 IF ExitLater% = 1 THEN
  '***Reselect old selected Line
  Row% = SelectedLine%
  GOSUB LineSelecter
  '**cursor on
  WriteLine (1)
  EXIT SUB
 END IF

 FGsetcolor 11
 FGboxdepth 304, 1
 
 FOR Row% = 1 TO 6

  HighlightLine (Row%)

  DO
   CALL BGDELAY(time.to.wait!, time.to.go!, st%)
   FGwaitfor 1  'Slow fast machines down for keyboard "poll"
   IF INKEY$ <> "" THEN GOSUB DTheKey
   JBut% = FGbutton(1)
   IF JBut% <> 0 THEN
    DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
    GOSUB DTheKey
   END IF
   LOOP UNTIL st% = 0

  HighlightLine (Row%)

  IF KeyTrap% = 1 THEN EXIT FOR

 NEXT Row%

LOOP UNTIL KeyTrap% = 1


'**Select New selected Line
SelectedLine% = Row%
GOSUB LineSelecter

'**cursor on
WriteLine (1)

EXIT SUB

DTheKey:

 KeyTrap% = 1

RETURN

LineSelecter:

HighlightLine (Row%)

RETURN

END SUB

SUB Send2Lpt (A$)

'**New page request="" flush PrnStr$ to printer
IF A$ = CHR$(12) + CHR$(12) + CHR$(12) AND KeyWord$(9) = "ON" THEN
 '**if string do not have a <cr> as last chr put it there
 IF RIGHT$(PrnStr$, 1) <> CHR$(13) THEN PrnStr$ = PrnStr$ + CHR$(13)
 LPRINT PrnStr$ + CHR$(12)
 PrnStr$ = ""
 A$ = ""
END IF

'**Add to PrnStr$ or LPrint A$ directly to Printer
IF KeyWord$(9) = "ON" THEN
  PrnStr$ = PrnStr$ + A$
 ELSE
  LPRINT A$;
END IF

END SUB

SUB SendSerial (String2Send$)

'***Check if any letter should be translated
IF LEN(String2Send$) THEN
 FOR N% = 1 TO LEN(String2Send$)
  letter% = ASC(MID$(String2Send$, N%, 1))
  IF letter% <> TranslateTo%(letter%) THEN
   MID$(String2Send$, N%, 1) = CHR$(TranslateTo%(letter%))
  END IF
 NEXT N%
END IF

'***Com Mode 1
IF VAL(KeyWord$(12)) = 1 THEN

 '===========================================================================
 '                  I N I T I A L I Z E     V A R I A B L E S
 '===========================================================================

 Baud& = 2400                                       'Set the BaudRate
 Param$ = STR$(Baud&) + ",N,8,1,RS,OP,CD0,DS0"      'and Com Parameters


 '===========================================================================
 '                         M A I N     P R O G R A M
 '===========================================================================


 '***Open Com X, Param$                 'Open Port X with Parameters$

 Port% = FREEFILE

 SELECT CASE ComChan%                   'Will Require Swapping at &H400, &H402
  CASE 1                                'In order to Support Com 3 and 4
   OPEN "R", Port%, "COM1:" + Param$    'ComBase = &H3F8  (COM1)
  CASE 2                                'ComBase = &H2F8  (COM2)
   OPEN "R", Port%, "COM2:" + Param$
 END SELECT

 '***Send the Character/s Verbatim
 IF LEN(String2Send$) THEN
  PRINT #Port%, String2Send$;
 END IF

 CLOSE Port%

END IF

'***Com Mode 2
IF VAL(KeyWord$(12)) = 2 THEN

 IF LEN(String2Send$) THEN

   '***sometimes 2 last chr that are sent in
   '***a string get lost and the first time
   '***a string is sent more often than not
   '***there is a garbage chr in front, I
   '***don't have time to figure it out, so
   '***this must do for now.

   '***using chr 1 for start and chr 0 for stop
   OldString2Send$ = String2Send$
   String2Send$ = STRING$(3, CHR$(1)) + String2Send$ + STRING$(3, CHR$(0))

   '***Send the Character/s Verbatim

   Nochr% = 1
   DO
    A% = ASC(MID$(String2Send$, Nochr%, 1))
    OUT ComPortAddr%, A%
    '***set rts=1
    RTS 1
    '***waitfor cts=1
    DO: LOOP UNTIL GetCTS% = 1
    '***set rts=0
    RTS 0
    '***give server time to set rts=0 and return to rx loop
    FGwaitfor 1
    Nochr% = Nochr% + 1
   LOOP UNTIL Nochr% = LEN(String2Send$)

   String2Send$ = OldString2Send$
 END IF

END IF

END SUB

SUB SetCom (PortNo%)

DEF SEG = 0
 ComPortAddr% = PEEK(1022 + 2 * PortNo%) + 256 * PEEK(1023 + 2 * PortNo%)
DEF SEG


IF ComPortAddr% = 0 THEN
 PRINT "No COM port "; PortNo%
 END
END IF

END SUB

SUB SubTitle (A$)


'if keyword bla off exit sub
IF LEN(A$) = 0 THEN EXIT SUB

A$ = RTRIM$(A$)
MaxString% = LEN(A$)
IF MaxString% >= 11 THEN MaxString% = 9

BigXPos% = 37

FOR N% = 1 TO MaxString%

 L% = ASC(MID$(A$, N%, 1))

 '**Find Characters 32-255
 Y% = 190
 x% = 408
 I% = 0

 FOR M% = 32 TO 255
  IF L% = M% THEN EXIT FOR
  x% = x% + 16
  I% = I% + 1
  IF I% = 14 THEN
   Y% = Y% + 14
   I% = 0
   x% = 408
  END IF
 NEXT M%

 '***Draw letter in Subtitle
 BigXPos% = BigXPos% + 2
 BigSXPos% = BigXPos%
 BigYPos% = 382
 FOR M% = Y% - 6 TO Y% + 1
  FOR H% = x% TO x% + 7
   col% = FGgetpixel(H%, M%)
   IF col% = 1 THEN
     FGsetcolor 1
    ELSE
     FGsetcolor 7
   END IF
   FGrect BigXPos%, BigXPos% + 2, BigYPos%, BigYPos% + 2
   BigXPos% = BigXPos% + 2
  NEXT H%
  BigYPos% = BigYPos% + 2
  BigXPos% = BigSXPos%
 NEXT M%

 BigXPos% = BigXPos% + 15

NEXT N%

IF MaxString% < LEN(A$) THEN
 FGsetcolor 1
 FGrect BigXPos%, BigXPos% + 15, BigYPos% - 16, BigYPos%
 FGsetcolor 7
 FGmove BigXPos%, BigYPos% - 1: FGdraw BigXPos% + 5, BigYPos% - 1
 FGdraw BigXPos% + 11, BigYPos% - 7: FGdraw BigXPos% + 11, BigYPos% - 9
 FGdraw BigXPos% + 5, BigYPos% - 15
 FGdraw BigXPos%, BigYPos% - 15: FGdraw BigXPos%, BigYPos% - 1
 FGpaint BigXPos% + 1, BigYPos% - 2
END IF

END SUB

SUB TxtFG (A$)

FOR N% = 1 TO LEN(A$)
 Character$ = MID$(A$, N%, 1)

 '**which fontset to load

 IF ASC(Character$) < 127 THEN
  A% = FGFload("font\font0.fgx" + CHR$(0))
  FGCharacter$ = Character$
  '***Bogstavfejl
  IF ASC(Character$) = 105 OR ASC(Character$) = 108 THEN
   NewX% = FGgetxpos% - 2
   NewY% = FGgetypos%
   FGmove NewX%, NewY%
  END IF
 END IF

 IF ASC(Character$) > 126 AND ASC(Character$) < 221 THEN
  A% = FGFload("font\font1.fgx" + CHR$(0))
  FGCharacter$ = CHR$(ASC(Character$) - 94)
  '***(Frame error)
  IF ASC(Character$) = 191 OR ASC(Character$) = 180 OR ASC(Character$) = 217 THEN
   NewX% = FGgetxpos% - 1
   NewY% = FGgetypos%
   FGmove NewX%, NewY%
  END IF
  '***Letter Error
  IF ASC(Character$) = 161 THEN
   NewX% = FGgetxpos% - 2
   NewY% = FGgetypos%
   FGmove NewX%, NewY%
  END IF
 END IF

 IF ASC(Character$) > 220 THEN
  A% = FGFload("font\font2.fgx" + CHR$(0))
  FGCharacter$ = CHR$(ASC(Character$) - 188)
  '**Adjust hight
  X221% = FGgetxpos%
  Y221% = FGgetypos%
  FGmove X221%, Y221% - 2
 END IF

 '** print chr
 FGFprint FGCharacter$, LEN(FGCharacter$)

  '**Adjust hight >=221 error back
 IF ASC(Character$) > 220 THEN
  X221% = FGgetxpos%
  FGmove X221%, Y221%
 END IF

 '** unload fontset
 FGFunload -1

NEXT N%

END SUB

SUB Word

DO

 '**Erase colum for symbol
 FGsetcolor 1
 FGrect 13, 234, 205, 404
 
 FGsetcolor 11
 FGboxdepth 43, 1


 MinX% = 13
 MaxX% = 98

 DO

  '**Menu
  '**Erase colum for symbol
  FGsetcolor 1
  FGrect 13, 234, 205, 404

  FGsetcolor 11
  FGboxdepth 31, 1
  FGboxx 291, 352, 205, 259

  DO
   CALL BGDELAY(time.to.wait!, time.to.go!, st%)
   FGwaitfor 1  'Slow fast machines down for keyboard "poll"
   IF INKEY$ <> "" THEN ExitLater% = 1
   JBut% = FGbutton(1)
   IF JBut% <> 0 THEN
    DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
    ExitLater% = 1
   END IF
   FGmousepos MX%, MY%, MB%
   IF MB% <> 0 THEN
    FGboxx 291, 352, 205, 259
    RealyExit
    FGboxx 291, 352, 205, 259
   END IF
  LOOP UNTIL st% = 0

  FGboxx 291, 352, 205, 259
  FGboxdepth 43, 1

  IF ExitLater% = 1 THEN
   Group% = 1
   EXIT SUB
  END IF

  AddX% = 0
  FOR Colum% = 1 TO 7

   FGsetcolor 11
   FGboxx MinX% + AddX%, MaxX% + AddX%, 15, 173

   DO
    GOSUB GSymbol '***Display group symbol
    CALL BGDELAY(time.to.wait!, time.to.go!, st%)
    FGwaitfor 1  'Slow fast machines down for keyboard "poll"
    IF INKEY$ <> "" THEN GOSUB TheKey
    JBut% = FGbutton(1)
    IF JBut% <> 0 THEN
     DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
     GOSUB TheKey
    END IF
   LOOP UNTIL st% = 0

   FGboxx MinX% + AddX%, MaxX% + AddX%, 15, 173

   AddX% = AddX% + 88

   IF KeyTrap% = 1 THEN EXIT FOR

  NEXT Colum%

 LOOP UNTIL KeyTrap% = 1

 KeyTrap% = 0
 AddX% = AddX% - 88

'**
 DO: FGwaitfor 1: LOOP UNTIL INKEY$ = ""
'**




 '**Erase symbol for colum
 FGsetcolor 1
 FGrect 13, 234, 205, 404


 FGsetcolor 11
 FGboxdepth 43, 1


 MinY% = 15
 MaxY% = 29

 DO

  '**Menu
  '**Erase colum for symbol
  FGsetcolor 1
  FGrect 13, 234, 205, 404

  FGsetcolor 11
  FGboxdepth 31, 1
  FGboxx 291, 352, 205, 259

  DO
   CALL BGDELAY(time.to.wait!, time.to.go!, st%)
   FGwaitfor 1  'Slow fast machines down for keyboard "poll"
   IF INKEY$ <> "" THEN ExitLater% = 1
   JBut% = FGbutton(1)
   IF JBut% <> 0 THEN
    DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
    ExitLater% = 1
   END IF
   FGmousepos MX%, MY%, MB%
   IF MB% <> 0 THEN
    FGboxx 291, 352, 205, 259
    RealyExit
    FGboxx 291, 352, 205, 259
   END IF
  LOOP UNTIL st% = 0

  FGboxx 291, 352, 205, 259
  FGboxdepth 43, 1

  IF ExitLater% = 1 THEN
   Group% = 1
   EXIT SUB
  END IF

  AddY% = 0
  FOR Row% = 1 TO 10

   FGsetcolor 11
   FGboxx MinX% + AddX%, MaxX% + AddX%, MinY% + AddY%, MaxY% + AddY%

   DO
    GOSUB LoadPic '** go do your thing while waiting
    CALL BGDELAY(time.to.wait!, time.to.go!, st%)
    FGwaitfor 1  'Slow fast machines down for keyboard "poll"
    IF INKEY$ <> "" THEN GOSUB TheKey
    JBut% = FGbutton(1)
    IF JBut% <> 0 THEN
     DO: JBut% = FGbutton(1): LOOP UNTIL JBut% = 0
     GOSUB TheKey
    END IF
   LOOP UNTIL st% = 0

   FGsetcolor 11
   FGboxx MinX% + AddX%, MaxX% + AddX%, MinY% + AddY%, MaxY% + AddY%

   AddY% = AddY% + 16

   IF KeyTrap% = 1 THEN
    '**Print Word
    ArrNo% = Colum% + ((Row% * 7) - 7) - 1 + (SelectedPage% - 1) * 70
    Paste2Line (TheWords$(Colum% + ((Row% * 7) - 7) - 1 + (SelectedPage% - 1) * 70)), ArrNo%
    EXIT FOR
   END IF

  NEXT Row%

  AddY% = AddY% - 16

 LOOP UNTIL KeyTrap% = 1

 KeyTrap% = 0

 DO: FGwaitfor 1: LOOP UNTIL INKEY$ = ""

LOOP

EXIT SUB

LoadPic: '***Display picture

'***Do the user want to see prety pictures ?
IF KeyWord$(3) = "ON" THEN
 
 IF OldPic$ = TheCompanion$(Colum% + ((Row% * 7) - 7) - 1 + (SelectedPage% - 1) * 70) THEN GOTO NoPicLoad

 '**standard pixel run ???
 IF UCASE$(RIGHT$(TheCompanion$(Colum% + ((Row% * 7) - 7) - 1 + (SelectedPage% - 1) * 70), 4)) = ".SPR" THEN
 '**load pallet pcx
 '
 FGmove 13, 205
 R% = FGIdisplay("palpict.pcx" + CHR$(0), 2, FGIHandle%)

 '**Erase colum for symbol
 FGsetcolor 0
 FGrect 13, 234, 205, 404

 '**load standard pixel run
 '
 FGmove 13, 404
 R% = FGIdisplay(TheCompanion$(Colum% + ((Row% * 7) - 7) - 1 + (SelectedPage% - 1) * 70) + CHR$(0), 0, PictoHandle%)

 ELSE


 '**Erase colum for symbol
 FGsetcolor 1
 FGrect 13, 234, 205, 404

 '**See if it is a pcx file and retrive header
 S% = FGpcxhead("images\" + TheCompanion$(Colum% + ((Row% * 7) - 7) - 1 + (SelectedPage% - 1) * 70) + CHR$(0), PCXHeader)

 '***If it is a pcx go on
 IF S% = 0 THEN

  '**get dimension of picture window
  CalcPCXDim PcxSizeX%, PcxSizeY%

  '***now lets retrive the pal part of the file
  File% = FREEFILE
  OPEN "images\" + TheCompanion$(Colum% + ((Row% * 7) - 7) - 1 + (SelectedPage% - 1) * 70) FOR BINARY AS #File%
   LenghtOfFile& = LOF(File%)
   '**Go to the end of the file and load the Pal
   PalStart& = LenghtOfFile& - 768
   PCXPal$ = SPACE$(768)
   GET #File%, PalStart&, PCXPal$
  CLOSE #File%
  
  '***if it's 256 col. then go ahead
  IF MID$(PCXPal$, 1, 1) = CHR$(12) THEN
  
   '***Compare program reserved colors with pcx files  RGB
   IF MID$(PCXPal$, 2, 3) = CHR$(0) + CHR$(0) + CHR$(0) THEN '*col 0
    IF MID$(PCXPal$, 5, 3) = CHR$(0) + CHR$(0) + CHR$(171) THEN '*col 1
     IF MID$(PCXPal$, 23, 3) = CHR$(171) + CHR$(171) + CHR$(171) THEN '*col 7
      IF MID$(PCXPal$, 32, 3) = CHR$(87) + CHR$(255) + CHR$(87) THEN '*col 10
       IF MID$(PCXPal$, 35, 3) = CHR$(87) + CHR$(255) + CHR$(255) THEN '*col 11
	IF MID$(PCXPal$, 38, 3) = CHR$(255) + CHR$(87) + CHR$(87) THEN '*col 12
	 colors% = 1
	END IF
       END IF
      END IF
     END IF
    END IF
   END IF

   IF colors% = 1 THEN '*Color RGB test = true
    colors% = 0

    '***see if the picture will fit, if so load
    IF PcxSizeX% <= 221 THEN
      IF PcxSizeY% <= 199 THEN
	FGmove 13, 205
	'***set Picture Displayed
	 R% = FGshowpcx("images\" + TheCompanion$(Colum% + ((Row% * 7) - 7) - 1 + (SelectedPage% - 1) * 70) + CHR$(0), 2)
       ELSE
	'**Erase any picture
	FGsetcolor 1
	FGrect 13, 234, 205, 404
	FGsetcolor 7
	FGmove 16, 216
	TxtFG ("ERROR Picture to big to fit")
	FGmove 16, 232
	TxtFG ("Picture Name:" + TheCompanion$(Colum% + ((Row% * 7) - 7) - 1 + (SelectedPage% - 1) * 70))
	FGwaitfor 90
	'**Erase text
	FGsetcolor 1
	FGrect 13, 234, 205, 404
      END IF '*end for is Y size to big
     ELSE
       '**Erase any picture
       FGsetcolor 1
       FGrect 13, 234, 205, 404
       FGsetcolor 7
       FGmove 16, 216
       TxtFG ("ERROR Picture to big to fit")
       FGmove 16, 232
       TxtFG ("Picture Name:" + TheCompanion$(Colum% + ((Row% * 7) - 7) - 1 + (SelectedPage% - 1) * 70))
       FGwaitfor 90
       '**Erase text
       FGsetcolor 1
       FGrect 13, 234, 205, 404
     END IF '*end for is X size to big
   ELSE
     '**Erase any picture
     FGsetcolor 1
     FGrect 13, 234, 205, 404
     FGsetcolor 7
     FGmove 16, 216
     TxtFG ("ERROR This picture is using")
     FGmove 16, 232
     TxtFG ("program reserved colors")
     FGmove 16, 248
     TxtFG ("with wrong RGB settings")
     FGmove 16, 264
     TxtFG ("if problem persist try to")
     FGmove 16, 280
     TxtFG ("use the FORCEPAL.EXE")
     FGmove 16, 296
     TxtFG ("utility")
     FGmove 16, 312
     TxtFG ("file name:" + TheCompanion$(Colum% + ((Row% * 7) - 7) - 1 + (SelectedPage% - 1) * 70))
     FGwaitfor 144
     '**Erase text
     FGsetcolor 1
     FGrect 13, 234, 205, 404
   END IF '*Color RGB test = true
   ELSE
     '**Erase any picture
     FGsetcolor 1
     FGrect 13, 234, 205, 404
     FGsetcolor 7
     FGmove 16, 216
     TxtFG ("ERROR This file is not")
     FGmove 16, 232
     TxtFG ("recognized as a 256 color")
     FGmove 16, 248
     TxtFG ("PCX File")
     FGmove 16, 264
     TxtFG ("file name:" + TheCompanion$(Colum% + ((Row% * 7) - 7) - 1 + (SelectedPage% - 1) * 70))
     FGwaitfor 90
     '**Erase text
     FGsetcolor 1
     FGrect 13, 234, 205, 404
  END IF '*(is it 256 col. then go ahead)
  ELSE
   '**Make sure it's not a macro
   Test4macro$ = TheWords$(Colum% + ((Row% * 7) - 7) - 1 + (SelectedPage% - 1) * 70)
   Test4PCX$ = TheCompanion$(Colum% + ((Row% * 7) - 7) - 1 + (SelectedPage% - 1) * 70)
   IF MID$(Test4macro$, 1, 1) <> ")" AND MID$(Test4macro$, 1, 1) <> "}" AND MID$(Test4macro$, 1, 1) <> "]" AND LEN(Test4PCX$) <> 0 THEN
    '**Erase any picture
    FGsetcolor 1
    FGrect 13, 234, 205, 404
    FGsetcolor 7
    FGmove 16, 216
    TxtFG ("ERROR This file is not")
    FGmove 16, 232
    TxtFG ("recognized as a graphical")
    FGmove 16, 248
    TxtFG ("PCX File")
    FGmove 16, 264
    TxtFG ("file name:" + TheCompanion$(Colum% + ((Row% * 7) - 7) - 1 + (SelectedPage% - 1) * 70))
    FGwaitfor 90
    '**Erase text
    FGsetcolor 1
    FGrect 13, 234, 205, 404
   END IF
 END IF '**If it is a pcx go on
 
 END IF '**standard pixel run ???

 OldPic$ = TheCompanion$(Colum% + ((Row% * 7) - 7) - 1 + ((SelectedPage% - 1) * 70))

NoPicLoad:

END IF '*end Keyword said off

RETURN

TheKey:

 KeyTrap% = 1

RETURN

GSymbol: '***Display group symbol

'***set Symbols Displayed
IF KeyWord$(4) = "ON" THEN

 FGmove 13, 205
 R% = FGIdisplay("palpict.pcx" + CHR$(0), 2, FGIHandle%)

 FGmove 13, 404

 SELECT CASE Colum%

  CASE 1
    R% = FGIdisplay("cirkel.spr" + CHR$(0), 0, FGIHandle%)

  CASE 2
   R% = FGIdisplay("trekant.spr" + CHR$(0), 0, FGIHandle%)

  CASE 3
   R% = FGIdisplay("boelge.spr" + CHR$(0), 0, FGIHandle%)

  CASE 4
   R% = FGIdisplay("firkant.spr" + CHR$(0), 0, FGIHandle%)

  CASE 5
   R% = FGIdisplay("stjerne.spr" + CHR$(0), 0, FGIHandle%)

  CASE 6
   R% = FGIdisplay("plus.spr" + CHR$(0), 0, FGIHandle%)

  CASE 7
   R% = FGIdisplay("dstreg.spr" + CHR$(0), 0, FGIHandle%)

 END SELECT

END IF

RETURN

END SUB

SUB WriteLine (CursorOnOff%)


'**Display string

HighlightLine (SelectedLine%)

SELECT CASE SelectedLine%
 CASE 1
  FGmove 16, 424
 CASE 2
  FGmove 16, 432
 CASE 3
  FGmove 16, 440
 CASE 4
  FGmove 16, 448
 CASE 5
  FGmove 16, 456
 CASE 6
  FGmove 16, 464
END SELECT

x% = FGgetxpos%
Y% = FGgetypos%

FGsetcolor 1
TxtFG (STRING$(76, CHR$(219)))

FGmove x%, Y%

FGsetcolor 7
IF CursorOnOff% = 1 THEN
  TxtFG (LineChr$(SelectedLine%)) + CHR$(219)
 ELSE
  TxtFG (LineChr$(SelectedLine%))
END IF
HighlightLine (SelectedLine%)

END SUB

